package Outils;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

/** Classe contenant les variables et fonctions globales. */
public class Global {

/*--------------------*/
/* VARIABLES GLOBALES */
/*--------------------*/

/** Correspond au caract&egrave;re : &quot;. */
	public static final String QUOT="\"";
/** Correspond au caract&egrave;re : &lt;. */
	public static final String LT ="<";
/** Correspond au caract&egrave;re : &gt;. */
	public static final String GT =">";
/** Correspond au caract&egrave;re : &amp;. */
	public static final String AMP="&";
/** Correspond au caract&egrave;re : &brvbar;. */
	public static final String PIPE="|";
/** Correspond au caract&egrave;re : #. */
	public static final String DIEZ="#";
/** Correspond au caract&egrave;re : !. */
	public static final String EXCL="!";
/** Correspond au retour &agrave; la ligne. */
	public static final String CRLF="\r\n";

/*--------------------*/
/** FONCTIONS GLOBALES */
/*--------------------*/

/** R&eacute;cup&egrave;re une chaine de caract&egave;s suite &agrave& une saisie texte.
 * @return la chaine saisie
 * @throws IOException
 */

	public static String readln() throws IOException{
		String buf;
		byte[] data;
		byte[] first=new byte[1];
		byte[] crlf =new byte[2];
		int limite;
		
		try{
			first[0]=(byte)System.in.read();
			limite=System.in.available();
			if (limite <2){
				System.in.read(crlf);
				return "";
			}
			else{
				data=new byte[limite-2];
				System.in.read(data);
				System.in.read(crlf);
				buf=new String(first);
				buf=buf.concat(new String(data));
				return buf;
			}
		}
		catch (IOException e){
			throw e;
		}
		/* ou plus simplement :
		BufferedReader in=new BufferedReader(new InputStreamReader(Systemin));
		return inreadLine();
		*/
	}

/** LECTURE D'UN ENTIER DANS LE FLUX INPUTSTREAM */

/** R&eacute;cup&egrave;re un entier &agrave; la saisie.
 * @return la valeur saisie
 * @throws Exception Il peut s'agir soit d'une saisie erronn&eacute;e, soit d"une erreur I/O
 */

	public static int readInt() throws Exception{
		String buf;
		byte[] data;
		byte[] first=new byte[1];
		byte[] crlf =new byte[2];
		int limite;
		Integer entier;
		
		try{
			first[0]=(byte)System.in.read();
			limite=System.in.available();
			if (limite >2) data=new byte[limite-2];
			else data = new byte[0];
			System.in.read(data);
			System.in.read(crlf);
			buf=new String(first);
			buf=buf.concat(new String(data));
			try {
				entier = new Integer(buf);
			}
			catch (NumberFormatException e2){
				throw (Exception)e2;
			}
		}
		catch (IOException e){
			throw (Exception)e;
		}
		
		return entier.intValue();
	}

/** Affiche un message d'erreur.
 * @param msg le message &agrave; afficher.
 * @param end si Vrai alors l'application se termine.
 */

	public static void msgErreur(String msg, boolean end){
		new fMsgErreur(msg,end);
}

/** Test si une chaine de caract&egrave;res est vide et la remplace par une autre si c'est le cas.
 * @param s la chaine &agrave; tester.
 * @param s la chaine de remplacement.
 * @return la nouvelle chaine.
 */

	public static String nonVide(String s,String r){
		if (s.length()==0){return r;}
		else return s;
	}

/********************************************/
/** Fonctions de suppression dans un vecteur */
/********************************************/

/**
 * Permet de supprimer un objet dans un vecteur.
 * @param v le vecteur.
 * @param i l'index de l'objet &agrave; supprimer.
 * @return Vrai si l'&eacute;l&eacute;ment a &eacute;t&eacute; supprim&eacute;.
 */
	public static boolean suppression (Vector v, int i){
		try{
			v.removeElementAt(i);
		}
		catch (ArrayIndexOutOfBoundsException e){
			return false;
		}
		return true;
	}

/**
 * Permet de supprimer toutes les occurrences d'un objet dans un vecteur.
 * @param v le vecteur.
 * @param o l'objet &agrave; supprimer.
 * @return Vrai si l'&eacute;l&eacute;ment a &eacute;t&eacute; supprim&eacute;.
 */
	
	public static boolean suppresAll (Vector v, Object o){
		boolean loop=true;
		boolean resultat = false;
		
		while (loop){
			loop=v.remove(o);	
			resultat|=loop;
		}
		return resultat;
	}
	
/** Retourne la chaine de caract&egrave;res si la condition est v&eacute;rifi&eacute;e.
 * @param s la chaine &agrave; retourner.
 * @param b la condition.
 * @return la chaine pass&eacute;e en entr&eacute;e si la condition est v&eacute;rifi&eacute;e, une chaine vide sinon.
 */
 
	public static String sVerif(String s, boolean b){
		if (b) return s;
		else return "";
	}
	 
}
