package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Fen&ecirc;tre d'ajout de plage horaire.
 */
public class afficheCal{
	private AGENDA agenda;
	private Frame pere;

	private String[] arguments;
	private Vector listeUtil=new Vector();		/*Liste de l'ensemble des utilisateurs de l'agenda*/
	private Vector listeNomUtil=new Vector();	/*Liste des utilisateurs contenant uniquement nom+prnom*/
	private Vector listePart;			/*liste d'affichage des participants*/
	private Vector listeIdPart;			/*liste des Id des participants*/
	private String URL;
	private Vector listeURL;			/*liste d'URL*/

	private JList jListParticipants;
	private JList jListUtilisateurs;
	private JList jListURL;
	private JButton bAjouterPart;
	private JButton bSupprimerPart;
	private JButton bAjouterURL;
	private JButton bSupprimerURL;
	private JButton bOk;
	private JButton bAnnuler;

	Renderer r;
	Frame f;
	
/** Cr&eacute;ation de l'instance de la fen&ecirc;tre.
 * @param a le nom du fichier de configuration.
 */
	public afficheCal(AGENDA a,Frame p){
		agenda=a;
		pere=p;

		r=new Renderer();
		r.renderUIML("smart1.uiml");
		Frame f = (Frame)r.getPartByName("frameafficheCal");

		jListParticipants=((JList)r.getPartByName("ListParticipants"));
		jListUtilisateurs=((JList)r.getPartByName("ListUtilisateurs"));
		jListURL=((JList)r.getPartByName("ListURL"));
		bAjouterPart=(JButton)r.getPartByName("ButtonAjouterParticipants");
		bAjouterPart.addActionListener(new smart1ActionAdapter(this,1));
		bSupprimerPart=(JButton)r.getPartByName("ButtonSupprimerParticipants");
		bSupprimerPart.addActionListener(new smart1ActionAdapter(this,2));
		bAjouterURL=(JButton)r.getPartByName("ButtonAjouterURL");
		bAjouterURL.addActionListener(new smart1ActionAdapter(this,3));
		bSupprimerURL=(JButton)r.getPartByName("ButtonSupprimerURL");
		bSupprimerURL.addActionListener(new smart1ActionAdapter(this,4));
		bOk=(JButton)r.getPartByName("ButtonOk");
		bOk.addActionListener(new smart1ActionAdapter(this,5));
		bAnnuler=(JButton)r.getPartByName("ButtonAnnuler");
		bAnnuler.addActionListener(new retourActionAdapter(f,pere));

		init();
	}

	private void init(){
		listeUtil = agenda.utilisateurs();
		listeNomUtil = nomPrenom(listeUtil);
		arguments=new String[6];
		listePart = new Vector();
		listeIdPart = new Vector();
		listeURL = new Vector();

		jListParticipants.setListData(listePart);
		jListUtilisateurs.setListData(listeNomUtil);
		jListURL.setListData(listeURL);

		((TextField)r.getPartByName("TextFieldDateDebut")).setText("");
		((TextField)r.getPartByName("TextFieldHeureDebut")).setText("");
		((TextField)r.getPartByName("TextFieldDateFin")).setText("");
		((TextField)r.getPartByName("TextFieldHeureFin")).setText("");
		((TextField)r.getPartByName("TextFieldObjet")).setText("");
		((TextField)r.getPartByName("TextFieldURL")).setText("");
		((TextArea)r.getPartByName("TextAreaDescription")).setText("");
	}

/** Ajoute l'utilisateur slectionn dans la liste des participants*/
	public void ajoutParticipants(){
		int i=jListUtilisateurs.getSelectedIndex();
		if (i!=-1){
			listeIdPart.add(((UTILISATEUR)listeUtil.elementAt(i)).getId());
			listePart.add(((UTILISATEUR)listeUtil.elementAt(i)).getNom()+" "+((UTILISATEUR)listeUtil.elementAt(i)).getPrenom());
			jListParticipants.setListData(listePart);
		}
	}

/** Supprime l'utilisateur slectionn de la liste des participants*/
	public void suppParticipants(){
		int i=jListParticipants.getSelectedIndex();
		if (i!=-1){
			listeIdPart.removeElementAt(i);
			listePart.removeElementAt(i);
			jListParticipants.setListData(listePart);
		}
	}

/** Ajoute l'URL saisie dans la liste d'URL*/
	public void ajoutURL(){
		URL=((TextField)r.getPartByName("TextFieldURL")).getText();
		if (URL.compareTo("")!=0){
			listeURL.addElement(URL);
			jListURL.setListData(listeURL);
			((TextField)r.getPartByName("TextFieldURL")).setText("");
		}
	}

/** Supprime l'URL slectionne de la liste d'URL*/
	public void suppURL(){
		int i=jListURL.getSelectedIndex();
		if (i!=-1){
			listeURL.removeElementAt(i);
			jListURL.setListData(listeURL);
		}
	}

/** Ajoute une plage horraire*/
	public void ok(){
		arguments[0]=((TextField)r.getPartByName("TextFieldDateDebut")).getText();
		arguments[1]=((TextField)r.getPartByName("TextFieldHeureDebut")).getText();
		arguments[2]=((TextField)r.getPartByName("TextFieldDateFin")).getText();
		arguments[3]=((TextField)r.getPartByName("TextFieldHeureFin")).getText();
		arguments[4]=((TextField)r.getPartByName("TextFieldObjet")).getText();
		arguments[5]=((TextArea)r.getPartByName("TextAreaDescription")).getText();
		if((arguments[0].compareTo("")==0) || (arguments[1].compareTo("")==0) || (arguments[2].compareTo("")==0) || (arguments[3].compareTo("")==0) || (arguments[4].compareTo("")==0)){
			Global.msgErreur("La saisie est incomplete!",false);
		}
		else{
			agenda.addPlageHoraire(arguments,listeURL,listeIdPart);
			init();
		}
	}

/** Transforme une liste d'utilisateurs en une liste de "nom+prnom" de ces mmes utilisateurs*/
/** @param u, liste d'utilisateurs*/
	private Vector nomPrenom(Vector u){
		Vector v=new Vector();
		int i;
		for(i=0;i<u.size();i++){
			v.add(((UTILISATEUR)u.elementAt(i)).getNom()+" "+((UTILISATEUR)u.elementAt(i)).getPrenom());
		}
		return v;
	}

/** Permet de rendre la frame visible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}