package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Fen&ecirc;tre d'affichage d'un jour.*/
public class afficheJour extends MyFrame{
	private fAfficheCal pere1;
	private afficheSemaine pere2;
	int origine;				/*Fentre d'origine (fAfficheCal=1 et afficheSemaine=2)*/

	private AGENDA agenda;
	Vector plageHoraire = new Vector();	/*Listes de toutes les plages horaires de l'agenda*/
	Vector[] listePH = new Vector[24];	/*Tableau contenant 24 listes de plages horaires (1 par heure)*/
	private DATE jour;			/*Date du jour*/

	private JButton bPrevious;
	private JButton bNext;
	private JButton bModifier;
	private JButton bSupprimer;
	private JButton bRetour;
	private Label lJour;

	Renderer r;
	Frame f;


/*Constructeur lorsque l'on vient de "fAfficheCal" (origine=1)*/
	public afficheJour(fAfficheCal fa,int j,AGENDA a,DATE d){
		r=new Renderer();
		r.renderUIML("smart3.uiml");
		f=(Frame)r.getPartByName("frameafficheJour");

		pere1=fa;
		origine=1;
		agenda=a;
		plageHoraire=agenda.m_Plage_Horaire;
		try{
			jour = new DATE (j,d.getMois(),d.getAnnee());
		}
		catch (DATEException e){
			jour=pere1.getCalendrier();
		}

		lJour=(Label)r.getPartByName("LabelJour");
		bPrevious=(JButton)r.getPartByName("ButtonPrevious");
		bPrevious.addActionListener(new smart3ActionAdapter(this,1));
		bNext=(JButton)r.getPartByName("ButtonNext");
		bNext.addActionListener(new smart3ActionAdapter(this,2));
		bModifier=(JButton)r.getPartByName("ButtonModifier");
		bModifier.addActionListener(new smart3ActionAdapter(this,3));
		bSupprimer=(JButton)r.getPartByName("ButtonSupprimer");
		bSupprimer.addActionListener(new smart3ActionAdapter(this,4));
		bRetour=(JButton)r.getPartByName("ButtonRetour");
		bRetour.addActionListener(new smart3ActionAdapter(this,5));

		init();
	}

/*Constructeur lorsque l'on vient de "afficheSemaine" (origine=2)*/
	public afficheJour(afficheSemaine as,DATE d,AGENDA a){
		r=new Renderer();
		r.renderUIML("smart3.uiml");
		f=(Frame)r.getPartByName("frameafficheJour");

		pere2=as;
		origine=2;
		agenda=a;
		plageHoraire=agenda.m_Plage_Horaire;
		try{
			jour = new DATE (d.getJour(),d.getMois(),d.getAnnee());
		}
		catch (DATEException e){
			jour=pere2.getCalendrier();
		}

		lJour=(Label)r.getPartByName("LabelJour");
		bPrevious=(JButton)r.getPartByName("ButtonPrevious");
		bPrevious.addActionListener(new smart3ActionAdapter(this,1));
		bNext=(JButton)r.getPartByName("ButtonNext");
		bNext.addActionListener(new smart3ActionAdapter(this,2));
		bModifier=(JButton)r.getPartByName("ButtonModifier");
		bModifier.addActionListener(new smart3ActionAdapter(this,3));
		bSupprimer=(JButton)r.getPartByName("ButtonSupprimer");
		bSupprimer.addActionListener(new smart3ActionAdapter(this,4));
		bRetour=(JButton)r.getPartByName("ButtonRetour");
		bRetour.addActionListener(new smart3ActionAdapter(this,5));

		init();
	}

	private void init(){
		lJour.setText(jour.getJour()+"/"+jour.getMois()+"/"+jour.getAnnee());

	/*Initialisation du tableau de plages horraires listePH*/
		for(int i=0;i<24;i++){
			listePH[i]=new Vector();
			}

	/*Insertion des plages horaires de la liste "plageHoraire" dans "listePH*/
		for(int i=0;i<plageHoraire.size();i++){
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,0,0,1,0)){
				listePH[0].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,1,0,2,0)){
				listePH[1].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,2,0,3,0)){
				listePH[2].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,3,0,4,0)){
				listePH[3].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,4,0,5,0)){
				listePH[4].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,5,0,6,0)){
				listePH[5].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,6,0,7,0)){
				listePH[6].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,7,0,8,0)){
				listePH[7].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,8,0,9,0)){
				listePH[8].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,9,0,10,0)){
				listePH[9].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,10,0,11,0)){
				listePH[10].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,11,0,12,0)){
				listePH[11].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,12,0,13,0)){
				listePH[12].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,13,0,14,0)){
				listePH[13].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,14,0,15,0)){
				listePH[14].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,15,0,16,0)){
				listePH[15].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,16,0,17,0)){
				listePH[16].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,17,0,18,0)){
				listePH[17].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,18,0,19,0)){
				listePH[18].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,19,0,20,0)){
				listePH[19].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,20,0,21,0)){
				listePH[20].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,21,0,22,0)){
				listePH[21].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,22,0,23,0)){
				listePH[22].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jour,23,0,23,59)){
				listePH[23].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
		}

		((JList)r.getPartByName("List0")).setListData(listePH[0]);
		((JList)r.getPartByName("List1")).setListData(listePH[1]);
		((JList)r.getPartByName("List2")).setListData(listePH[2]);
		((JList)r.getPartByName("List3")).setListData(listePH[3]);
		((JList)r.getPartByName("List4")).setListData(listePH[4]);
		((JList)r.getPartByName("List5")).setListData(listePH[5]);
		((JList)r.getPartByName("List6")).setListData(listePH[6]);
		((JList)r.getPartByName("List7")).setListData(listePH[7]);
		((JList)r.getPartByName("List8")).setListData(listePH[8]);
		((JList)r.getPartByName("List9")).setListData(listePH[9]);
		((JList)r.getPartByName("List10")).setListData(listePH[10]);
		((JList)r.getPartByName("List11")).setListData(listePH[11]);
		((JList)r.getPartByName("List12")).setListData(listePH[12]);
		((JList)r.getPartByName("List13")).setListData(listePH[13]);
		((JList)r.getPartByName("List14")).setListData(listePH[14]);
		((JList)r.getPartByName("List15")).setListData(listePH[15]);
		((JList)r.getPartByName("List16")).setListData(listePH[16]);
		((JList)r.getPartByName("List17")).setListData(listePH[17]);
		((JList)r.getPartByName("List18")).setListData(listePH[18]);
		((JList)r.getPartByName("List19")).setListData(listePH[19]);
		((JList)r.getPartByName("List20")).setListData(listePH[20]);
		((JList)r.getPartByName("List21")).setListData(listePH[21]);
		((JList)r.getPartByName("List22")).setListData(listePH[22]);
		((JList)r.getPartByName("List23")).setListData(listePH[23]);
	}

/** Affiche la fentre du jour prcdent.
 */
	public void previous(){
		jour.decalJour(-1);
		init();
	}

/** Affiche la fentre du jour suivant.
 */
	public void next(){
		jour.decalJour(1);
		init();
	}

/** Permet de retourner  la fentre prcdente.
 */
	public void back(){
		if(origine==1) pere1.setVisible(true);
		if(origine==2) pere2.setVisible(true);
		setVisible(false);
	}

/** Permet de rendre la frame visible ou invisible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}