package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Fen&ecirc;tre d'affichage d'une semaine.*/
public class afficheSemaine extends MyFrame{
	private fAfficheCal pere;
	int semaine;				/*Numro de la semaine o l'on se trouve*/
	private AGENDA agenda;
	private DATE calendrier;
	Vector[] listePH = new Vector[7];	/*Tableau contenant 7 listes de plages horaires (1 par jour)*/
	Vector plageHoraire = new Vector();	/*Listes de toutes les plages horaires de l'agenda*/

	private JButton bPrevious;
	private JButton bNext;
	private JButton bLundi;
	private JButton bMardi;
	private JButton bMercredi;
	private JButton bJeudi;
	private JButton bVendredi;
	private JButton bSamedi;
	private JButton bDimanche;
	private JButton bModifier;
	private JButton bSupprimer;
	private JButton bRetour;

	private DATE lundi;
	private DATE mardi;
	private DATE mercredi;
	private DATE jeudi;
	private DATE vendredi;
	private DATE samedi;
	private DATE dimanche;

	Renderer r;
	Frame f;

/** Cr&eacute;ation de l'instance de la fen&ecirc;tre.
 * @param a le nom du fichier de configuration.
 */
	public afficheSemaine(fAfficheCal fa,int s,AGENDA a,DATE d){
		pere=fa;
		semaine=s;
		agenda=a;
		try{
			calendrier = new DATE();
		}
		catch (DATEException e){
			Global.msgErreur("Probleme pour la recuperation de la date courante",true);
		}
		calendrier=d;

		r=new Renderer();
		r.renderUIML("smart2.uiml");
		Frame f = (Frame)r.getPartByName("frameafficheSemaine");

		bPrevious=(JButton)r.getPartByName("ButtonPrevious");
		bPrevious.addActionListener(new smart2ActionAdapter(this,1));
		bNext=(JButton)r.getPartByName("ButtonNext");
		bNext.addActionListener(new smart2ActionAdapter(this,2));
		bLundi=(JButton)r.getPartByName("ButtonLundi");
		bLundi.addActionListener(new smart2ActionAdapter(this,3));
		bMardi=(JButton)r.getPartByName("ButtonMardi");
		bMardi.addActionListener(new smart2ActionAdapter(this,4));
		bMercredi=(JButton)r.getPartByName("ButtonMercredi");
		bMercredi.addActionListener(new smart2ActionAdapter(this,5));
		bJeudi=(JButton)r.getPartByName("ButtonJeudi");
		bJeudi.addActionListener(new smart2ActionAdapter(this,6));
		bVendredi=(JButton)r.getPartByName("ButtonVendredi");
		bVendredi.addActionListener(new smart2ActionAdapter(this,7));
		bSamedi=(JButton)r.getPartByName("ButtonSamedi");
		bSamedi.addActionListener(new smart2ActionAdapter(this,8));
		bDimanche=(JButton)r.getPartByName("ButtonDimanche");
		bDimanche.addActionListener(new smart2ActionAdapter(this,9));
		bModifier=(JButton)r.getPartByName("ButtonModifier");
		bModifier.addActionListener(new smart2ActionAdapter(this,10));
		bSupprimer=(JButton)r.getPartByName("ButtonSupprimer");
		bSupprimer.addActionListener(new smart2ActionAdapter(this,11));
		bRetour=(JButton)r.getPartByName("ButtonRetour");
		bRetour.addActionListener(new smart2ActionAdapter(this,12));

		init();
	}

	private void init(){
		plageHoraire=agenda.m_Plage_Horaire;

		((Label)r.getPartByName("LabelSemaine")).setText("Semaine "+semaine);

		lundi=getDateLundi(semaine);							/*date du lundi*/
		mardi=getDateLundi(semaine); mardi.decalJour(1);				/*date du mardi*/
		mercredi=getDateLundi(semaine); mercredi.decalJour(2);				/*date du mercredi*/
		jeudi=getDateLundi(semaine); jeudi.decalJour(3);				/*date du jeudi*/
		vendredi=getDateLundi(semaine); vendredi.decalJour(4);				/*date du vendredi*/
		samedi=getDateLundi(semaine); samedi.decalJour(5);				/*date du samedi*/
		dimanche=getDateLundi(semaine); dimanche.decalJour(6);				/*date du dimanche*/

	/*Initialisation du tableau de plages horraires listePH*/
		for(int i=0;i<7;i++){
			listePH[i]=new Vector();
			}

	/*Insertion des plages horaires de la liste "plageHoraire" dans "listePH*/
		for(int i=0;i<plageHoraire.size();i++){
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(lundi,0,0,23,59)){
				listePH[0].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(mardi,0,0,23,59)){
				listePH[1].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(mercredi,0,0,23,59)){
				listePH[2].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(jeudi,0,0,23,59)){
				listePH[3].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(vendredi,0,0,23,59)){
				listePH[4].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(samedi,0,0,23,59)){
				listePH[5].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
			if(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).occupe(dimanche,0,0,23,59)){
				listePH[6].add(((PLAGE_HORAIRE)plageHoraire.elementAt(i)).getObjet());
			}
		}

		((JList)r.getPartByName("ListLundi")).setListData(listePH[0]);
		((JList)r.getPartByName("ListMardi")).setListData(listePH[1]);
		((JList)r.getPartByName("ListMercredi")).setListData(listePH[2]);
		((JList)r.getPartByName("ListJeudi")).setListData(listePH[3]);
		((JList)r.getPartByName("ListVendredi")).setListData(listePH[4]);
		((JList)r.getPartByName("ListSamedi")).setListData(listePH[5]);
		((JList)r.getPartByName("ListDimanche")).setListData(listePH[6]);

		System.out.println("SEMAINE  : "+semaine);
		System.out.println("LUNDI    : "+lundi.toString());
		System.out.println("MARDI    : "+mardi.toString());
		System.out.println("MERCREDI : "+mercredi.toString());
		System.out.println("JEUDI    : "+jeudi.toString());
		System.out.println("VENDREDI : "+vendredi.toString());
		System.out.println("SAMEDI   : "+samedi.toString());
		System.out.println("DIMANCHE : "+dimanche.toString());
	}

/** Retourne  la fentre prcdente.
 */
	public void back(){
		pere.setVisible(true);
		setVisible(false);
	}

/** Retourne la date du lundi de la semaine spcifie.
 * @param s le numro de la semaine.
 */
	public DATE getDateLundi(int s){
		return calendrier.getDateLundi(s);
	}

/** Affiche la fentre de la semaine prcdente.
 */
	public void previous(){
		if(semaine==calendrier.semaineMin()){
			calendrier.decalAnnee(-1);
			if(semaine==0) semaine=(calendrier.semaineMax()-1);
			else semaine=calendrier.semaineMax();
		}
		else{
			semaine--;
		}
		init();
	}

/** Affiche la fentre de la semaine suivante.
 */
	public void next(){
		if(semaine==calendrier.semaineMax()){
			calendrier.decalAnnee(1);
			if(calendrier.semaineMin()==0) semaine=(calendrier.semaineMin()+1);
			else semaine=calendrier.semaineMin();
		}
		else{
			semaine++;
		}
		init();
	}

/** Affiche la fentre du jour (1,2,3,4,5,6 ou 7) de la semaine.
 */
	public void affJour(int j){
		switch (j){
			case 1 : new afficheJour(this,lundi,agenda);break;
			case 2 : new afficheJour(this,mardi,agenda);break;
			case 3 : new afficheJour(this,mercredi,agenda);break;
			case 4 : new afficheJour(this,jeudi,agenda);break;
			case 5 : new afficheJour(this,vendredi,agenda);break;
			case 6 : new afficheJour(this,samedi,agenda);break;
			case 7 : new afficheJour(this,dimanche,agenda);break;
		}
		setVisible(false);
	}

/** Permet de r&eacute;cup&eacute;rer le calendrier.
 * @return le calendrier.
 */	
	public DATE getCalendrier(){
		return pere.getCalendrier();
	}

/** Permet de rendre la frame visible ou invisible.
 */
	public void setVisible(boolean b){
		((Frame)r.getPartByName("frameafficheSemaine")).setVisible(b);
	}

}