package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Affichage des utilisateurs (lecteurs et/ou administrateurs).
 */
public class fAfficheUtil extends MyFrame{
	private int utilisateurs=0;
	private int lastId;
	private boolean nouveau=false;
	private UTILISATEUR newUtil;
	
	private Vector listeUtilisateurs;
	private boolean administrateur;
	private AGENDA agenda;
	private int index=-1;
	private int portableSelected=-1;
	private int emailSelected=-1;
	private int indexAdresse=-1;
	private Vector postals;
	private Vector emails;
	private Vector portables;
	private Frame pere;
	
	public Vector lUtilisateurs=new Vector();
	public Vector listeEmail=new Vector();
	public Vector listePortable=new Vector();
	private int utilisateurSelected=0;
	private Vector liste=new Vector();
	
	private TextField tNom;
	private TextField tPrenom;
	private TextField tLogin;
	private TextField tPassWord;
	private TextField tNum;
	private TextField tRue;
	private TextField tCode;
	private TextField tVille;
	private TextField tTelephone;
	private TextField tFax;
	private TextField tId;
	
	private JCheckBox cNumRue;
	private JCheckBox cRue;
	private JCheckBox cVille;
	private JCheckBox cCodePostal;
	private JCheckBox cTelephone;
	private JCheckBox cFax;
	private JCheckBox cEmail;
	private JCheckBox cPortable;
	
	private TextField tEmail;
	private TextField tPortable;

	JButton bAfficher;
	JButton bPreviousAdr;
	JButton bNextAdr;
	JButton bPostalAjouter;
	JButton bPostalModifier;
	JButton bPostalSupprimer;
	JButton bEmailSupprimer;
	JButton bEmailAjouter;
	JButton bPortableSupprimer;
	JButton bPortableAjouter;
	JButton bNouveau;
	JButton bAjouter;
	JButton bSupprimer;
	JButton bModifier;
	JButton bRetour;

	Renderer r;
	Frame f;

/** Cr&eacute;ation de l'instance de la fen&ecirc;tre.
 * @param util d&eacute;termine la liste &agrave; afficher (lecteurs, administrateurs ou les deux).
 * @param adm d&eacute;termine si l'utilisateur est un administrateur ou pas.
 * @param a l'agenda.
 * @param p la fen&ecirc;tre pr&eacute;c&eacute;dente.
 */
	public fAfficheUtil(int util,boolean adm,AGENDA a,Frame p){
		postals=new Vector();
		emails=new Vector();
		portables=new Vector();
		
		utilisateurs=util;
			
		administrateur=adm;
		agenda=a;
		pere=p;
		switch(utilisateurs){
			case 1 : listeUtilisateurs=agenda.getAdministrateurs();break;
			case 2 : listeUtilisateurs=agenda.getLecteurs();break;
			case 3 : listeUtilisateurs=agenda.utilisateurs();break;
			default : listeUtilisateurs=agenda.utilisateurs();break;
		}

		r=new Renderer();
		r.renderUIML("smart5.uiml");
		f=(Frame)r.getPartByName("framefAfficheUtil");

		tNom=(TextField)r.getPartByName("TextFieldNom");
		tPrenom=(TextField)r.getPartByName("TextFieldPrenom");
		tLogin=(TextField)r.getPartByName("TextFieldLogin");
		tPassWord=(TextField)r.getPartByName("TextFieldPassWord");
		tId=(TextField)r.getPartByName("TextFieldID");
		tNum=(TextField)r.getPartByName("TextFieldNum");
		tRue=(TextField)r.getPartByName("TextFieldRue");
		tCode=(TextField)r.getPartByName("TextFieldCode");
		tVille=(TextField)r.getPartByName("TextFieldVille");
		tTelephone=(TextField)r.getPartByName("TextFieldTel");
		tFax=(TextField)r.getPartByName("TextFieldFax");
		tEmail=(TextField)r.getPartByName("TextFieldEmail");
		tPortable=(TextField)r.getPartByName("TextFieldPortable");
		cNumRue=(JCheckBox)r.getPartByName("CheckBoxNum");
		cRue=(JCheckBox)r.getPartByName("CheckBoxRue");
		cVille=(JCheckBox)r.getPartByName("CheckBoxVille");
		cCodePostal=(JCheckBox)r.getPartByName("CheckBoxCode");
		cTelephone=(JCheckBox)r.getPartByName("CheckBoxTel");
		cFax=(JCheckBox)r.getPartByName("CheckBoxFax");
		cEmail=(JCheckBox)r.getPartByName("CheckBoxEmail");
		cPortable=(JCheckBox)r.getPartByName("CheckBoxPortable");

		init();
		afficheListe(listeUtilisateurs);

		bAfficher=(JButton)r.getPartByName("ButtonAfficher");
		bAfficher.addActionListener(new smart5ActionAdapter(this,1,r));
		bPreviousAdr=(JButton)r.getPartByName("ButtonPreviousAdr");
		bPreviousAdr.addActionListener(new smart5ActionAdapter(this,2));
		bNextAdr=(JButton)r.getPartByName("ButtonNextAdr");
		bNextAdr.addActionListener(new smart5ActionAdapter(this,3));
		bPostalAjouter=(JButton)r.getPartByName("ButtonPostalAjouter");
		bPostalAjouter.addActionListener(new smart5ActionAdapter(this,4));
		bPostalModifier=(JButton)r.getPartByName("ButtonPostalModifier");
		bPostalModifier.addActionListener(new smart5ActionAdapter(this,5));
		bPostalSupprimer=(JButton)r.getPartByName("ButtonPostalSupprimer");
		bPostalSupprimer.addActionListener(new smart5ActionAdapter(this,6));
		bEmailSupprimer=(JButton)r.getPartByName("ButtonEmailSupprimer");
		bEmailSupprimer.addActionListener(new smart5ActionAdapter(this,7));
		bEmailAjouter=(JButton)r.getPartByName("ButtonEmailAjouter");
		bEmailAjouter.addActionListener(new smart5ActionAdapter(this,8));
		bPortableSupprimer=(JButton)r.getPartByName("ButtonPortableSupprimer");
		bPortableSupprimer.addActionListener(new smart5ActionAdapter(this,9));
		bPortableAjouter=(JButton)r.getPartByName("ButtonPortableAjouter");
		bPortableAjouter.addActionListener(new smart5ActionAdapter(this,10));
		bNouveau=(JButton)r.getPartByName("ButtonNouveau");
		bNouveau.addActionListener(new smart5ActionAdapter(this,11));
		bAjouter=(JButton)r.getPartByName("ButtonAjouter");
		bAjouter.addActionListener(new smart5ActionAdapter(this,12));
		bSupprimer=(JButton)r.getPartByName("ButtonSupprimer");
		bSupprimer.addActionListener(new smart5ActionAdapter(this,13));
		bModifier=(JButton)r.getPartByName("ButtonModifier");
		bModifier.addActionListener(new smart5ActionAdapter(this,14));
		bRetour=(JButton)r.getPartByName("ButtonRetour");
		bRetour.addActionListener(new smart5ActionAdapter(this,15));

		pere.setVisible(false);
		bAjouter.setVisible(false);
		bModifier.setVisible(false);
		bSupprimer.setVisible(false);
	}
	
	private void init(){
		if (administrateur && (utilisateurs!=3)){
			((Panel)r.getPartByName("PanelBoutonNouveau")).setVisible(true);
			((Panel)r.getPartByName("PanelBoutonAjouter")).setVisible(true);
			((Panel)r.getPartByName("PanelBoutonSupprimer")).setVisible(true);
			((Panel)r.getPartByName("PanelBoutonModifier")).setVisible(true);
		}
		else{
			((Panel)r.getPartByName("PanelBoutonNouveau")).setVisible(false);
			((Panel)r.getPartByName("PanelBoutonAjouter")).setVisible(false);
			((Panel)r.getPartByName("PanelBoutonSupprimer")).setVisible(false);
			((Panel)r.getPartByName("PanelBoutonModifier")).setVisible(false);
		}

		if (administrateur){
			((Panel)r.getPartByName("PanelID")).setVisible(true);
			((Panel)r.getPartByName("PanelLogin")).setVisible(true);
			((Panel)r.getPartByName("PanelPassWord")).setVisible(true);
			((Panel)r.getPartByName("PanelPostalBoutons")).setVisible(true);
			cNumRue.setVisible(true);
			cRue.setVisible(true);
			cCodePostal.setVisible(true);
			cVille.setVisible(true);
			cTelephone.setVisible(true);
			cFax.setVisible(true);
			((Panel)r.getPartByName("PanelViewEmail")).setVisible(true);
			((Panel)r.getPartByName("PanelViewPortable")).setVisible(true);
			((Panel)r.getPartByName("PanelModEmail")).setVisible(true);
			((Panel)r.getPartByName("PanelModPortable")).setVisible(true);
		}
		else{
			((Panel)r.getPartByName("PanelID")).setVisible(false);
			((Panel)r.getPartByName("PanelLogin")).setVisible(false);
			((Panel)r.getPartByName("PanelPassWord")).setVisible(false);
			((Panel)r.getPartByName("PanelPostalBoutons")).setVisible(false);
			cNumRue.setVisible(false);
			cRue.setVisible(false);
			cCodePostal.setVisible(false);
			cVille.setVisible(false);
			cTelephone.setVisible(false);
			cFax.setVisible(false);
			((Panel)r.getPartByName("PanelViewEmail")).setVisible(false);
			((Panel)r.getPartByName("PanelViewPortable")).setVisible(false);
			((Panel)r.getPartByName("PanelModEmail")).setVisible(false);
			((Panel)r.getPartByName("PanelModPortable")).setVisible(false);
		}
	}
	
/** Affichage de la liste des utilisateurs (lecteurs, administrateurs ou les deux).
 * @param v la liste &agrave; afficher.
 */
	public void afficheListe(Vector v){
		liste=v;
		int i=0;
		lUtilisateurs.removeAllElements();
		removeAll();
		for(i=0;i<v.size();i++){
			lUtilisateurs.add(((UTILISATEUR)v.elementAt(i)).getNom()+" "+((UTILISATEUR)v.elementAt(i)).getPrenom());
		}
		if (i>0){
			utilisateurSelected=-1;
		}
		((JList)r.getPartByName("ListUtilisateurs")).setListData(lUtilisateurs);
	}

/** Affichage d'un utilisateur.
 * @param v la liste des utilisateurs.
 * @param i l'index de l'utilisateur &agrave; afficher.
 */
	public void afficheUtil(Vector v,int i){
		removeAll();
		if (i<v.size()){
			tId.setText(((UTILISATEUR)v.elementAt(i)).getId());
			tNom.setText(((UTILISATEUR)v.elementAt(i)).getNom());
			tPrenom.setText(((UTILISATEUR)v.elementAt(i)).getPrenom());
			tLogin.setText(((UTILISATEUR)v.elementAt(i)).getLogin());
			tPassWord.setText(((UTILISATEUR)v.elementAt(i)).getPassWord());
			afficheAdresse(((UTILISATEUR)v.elementAt(i)).getAdresses(),0);	
		}
	}
	
/** Affichage d'une fiche d'adresses.
 * @param fiche la fiche d'un utilisateur.
 * @param i l'index de l'adresse postale &agrave; afficher.
 */
	public void afficheAdresse(FICHE fiche,int i){
		postals=fiche.getPostal();
		affichePostal(i);
		afficheAutreCom(fiche.getAutreCom());
	}
	
/** Affichage d'une adresse postale.
 * @param i l'index de l'adresse postale &agrave; afficher.
 */
	public void affichePostal(int i){
		if (postals.size()>0){
			if (i<0) i=postals.size()-1;
			else if (i>=postals.size()) i=0;
			indexAdresse=i;
			tNum.setText("");
			cNumRue.setSelected(false);
			if (administrateur || ((POSTAL)postals.elementAt(i)).getViewNumRue()){
				tNum.setText(((POSTAL)postals.elementAt(i)).getNumRue());
			}
			cNumRue.setSelected(((POSTAL)postals.elementAt(i)).getViewNumRue());
			tRue.setText("");
			cRue.setSelected(false);
			if (administrateur || ((POSTAL)postals.elementAt(i)).getViewRue()){
				tRue.setText(((POSTAL)postals.elementAt(i)).getRue());
			}
			cRue.setSelected(((POSTAL)postals.elementAt(i)).getViewRue());
			tCode.setText("");
			cCodePostal.setSelected(false);
			if (administrateur || ((POSTAL)postals.elementAt(i)).getViewCodePostal()){
				tCode.setText(((POSTAL)postals.elementAt(i)).getCodePostal());
			}
			cCodePostal.setSelected(((POSTAL)postals.elementAt(i)).getViewCodePostal());
			tVille.setText("");
			cVille.setSelected(false);
			if (administrateur || ((POSTAL)postals.elementAt(i)).getViewVille()){
				tVille.setText(((POSTAL)postals.elementAt(i)).getVille());
			}
			cVille.setSelected(((POSTAL)postals.elementAt(i)).getViewVille());
			tTelephone.setText("");
			cTelephone.setSelected(false);
			if (administrateur || ((POSTAL)postals.elementAt(i)).getViewTelephone()){
				tTelephone.setText(((POSTAL)postals.elementAt(i)).getTelephone());
			}
			cTelephone.setSelected(((POSTAL)postals.elementAt(i)).getViewTelephone());
			tFax.setText("");
			cFax.setSelected(false);
			if (administrateur || ((POSTAL)postals.elementAt(i)).getViewFax()){
				tFax.setText(((POSTAL)postals.elementAt(i)).getFax());
			}
			cFax.setSelected(((POSTAL)postals.elementAt(i)).getViewFax());
		}
	}
	
/** Affichage des e-mails et num&eacute;ros de portable.
 * @param a la classe contenant les e-mails et les num&eacute;ros de portables &agrave; afficher.
 */
	public void afficheAutreCom(AUTRE_COM a){
		((JList)r.getPartByName("ListEmail")).removeAll();
		((JList)r.getPartByName("ListPortable")).removeAll();
		emails=a.getEmails();
		portables=a.getPortables();
		listeEmail.removeAllElements();
		for(int i=0;i<emails.size();i++){
			if(((E_MAIL)emails.elementAt(i)).view() || administrateur){
				listeEmail.add(((E_MAIL)emails.elementAt(i)).email());
			}
		}
		((JList)r.getPartByName("ListEmail")).setListData(listeEmail);
		listePortable.removeAllElements();
		for(int i=0;i<portables.size();i++){
			if (((PORTABLE)portables.elementAt(i)).view() || administrateur){
				listePortable.add(((PORTABLE)portables.elementAt(i)).portable());
			}
		}
		((JList)r.getPartByName("ListPortable")).setListData(listePortable);
	}

/** Retourne &agrave; la fentre pr&eacute;c&eacute;dente.
 */
	public void back(){
		if (nouveau){
			tId.setText("");
			tNom.setText("");
			tPrenom.setText("");
			tLogin.setText("");
			tPassWord.setText("");
			nouveau=false;
			((Panel)r.getPartByName("PanelInfo")).setVisible(true);
			bAjouter.setVisible(false);
			bSupprimer.setVisible(true);
			bModifier.setVisible(true);
		}
		else{
			setVisible(false);
			pere.setVisible(true);
		}
	}

/** D&eacute;termine l'utilisateur s&eacute;lectionn&eacute;.
 * @return l'index de l'utilisateur s&eacute;lectionn&eacute;.
 */
	public int getUtilisateurSelected(){
		return utilisateurSelected;
	}
	
/** D&eacute;termine l'e-mail s&eacute;lectionn&eacute;.
 * @return l'index de l'e-mail  s&eacute;lectionn&eacute;.
 */
	public int getEmailSelected(){
		return emailSelected;
	}
	
/** D&eacute;termine le num&eacute;ro de portable s&eacute;lectionn&eacute;.
 * @return l'index du num&eacute;ro de portable  s&eacute;lectionn&eacute;.
 */
	public int getPortableSelected(){
		return portableSelected;
	}
	
/** S&eacute;lectionne un utilisateur.
 * @param i l'index de l'utilisateur  &agrave; s&eacute;lectionner.
 */
	public void setSelectedUtil(int i){
		nouveau=false;
		bAjouter.setVisible(false);
		bSupprimer.setVisible(true);
		bModifier.setVisible(true);
		((Panel)r.getPartByName("PanelInfo")).setVisible(true);
		utilisateurSelected=i;
		afficheUtil(listeUtilisateurs,utilisateurSelected);
	}
	
/** S&eacute;lectionne un e-mail.
 * @param i l'index de l'e-mail  &agrave; s&eacute;lectionner.
 */
	public void setSelectedEmail(int i){
		emailSelected=i;
		cEmail.setSelected(((E_MAIL)emails.elementAt(i)).view());
	}
	
/** S&eacute;lectionne un num&eacute;ro de portable.
 * @param i l'index du num&eacute;ro de portable  &agrave; s&eacute;lectionner.
 */
	public void setSelectedPortable(int i){
		portableSelected=i;
		cPortable.setSelected(((PORTABLE)portables.elementAt(i)).view());
	}

/** R&eacute;initialisation de l'affichage.
 */
	public void removeAll(){
		tNum.setText("");
		tRue.setText("");
		tCode.setText("");
		tVille.setText("");
		tTelephone.setText("");
		tFax.setText("");
		tEmail.setText("");
		((JList)r.getPartByName("ListEmail")).removeAll();
		tPortable.setText("");
		((JList)r.getPartByName("ListPortable")).removeAll();
		tNom.setText("");
		tPrenom.setText("");
		tLogin.setText("");
		tPassWord.setText("");
		tId.setText("");
	}

/** R&eacute;initialisation de l'affichage des adresses postales.
 */
	public void removePostal(){
		tNum.setText("");
		tRue.setText("");
		tCode.setText("");
		tVille.setText("");
		tTelephone.setText("");
		tFax.setText("");
	}

/** Affiche l'adresse postale suivante.
 */	
	public void nextAdresse(){
		indexAdresse++;
		affichePostal(indexAdresse);
	}
	
/** Affiche l'adresse postale pr&eacute;c&eacute;dente.
 */	
	public void previousAdresse(){
		indexAdresse--;
		affichePostal(indexAdresse);
	}
	
/** Supprime l'utilisateur s&eacute;lectionn&eacute;.
 */	
	public void erase(){
		boolean resultat=false;

		if (utilisateurSelected>=0){
			try{
				resultat=agenda.suppressionLecteur((UTILISATEUR)listeUtilisateurs.elementAt(utilisateurSelected));
			}
			catch (Exception e){
			}
			if(!resultat){
				try{			
					resultat=agenda.suppressionAdmin((UTILISATEUR)listeUtilisateurs.elementAt(utilisateurSelected));
				}
				catch (Exception e){
				}
			}
			removeAll();
			lUtilisateurs.remove(utilisateurSelected);
			((JList)r.getPartByName("ListUtilisateurs")).setListData(lUtilisateurs);
			if (((JList)r.getPartByName("ListUtilisateurs")).getComponentCount()>0){
				setSelectedUtil(0);
				((JList)r.getPartByName("ListUtilisateurs")).setSelectedIndex(0);
			}
			else utilisateurSelected=-1;
		}
	}
	
/** Supprime l'adresse postale s&eacute;lectionn&eacute;e.
 */	
	public void suppPostal(){
		if (indexAdresse>=0){
			agenda.suppressionAdresse(listeUtilisateurs,utilisateurSelected,indexAdresse);
			indexAdresse--;
			removePostal();
			affichePostal(indexAdresse);
		}
	}
	
/** Supprime l'adresse e-mail s&eacute;lectionn&eacute;e.
 */	
	public void suppEmail(){
		emailSelected=((JList)r.getPartByName("ListEmail")).getSelectedIndex();
		if (emailSelected>=0){
			agenda.suppressionEmail(listeUtilisateurs,utilisateurSelected,emailSelected);
			listeEmail.remove(emailSelected);
			((JList)r.getPartByName("ListEmail")).setListData(listeEmail);
			if (((JList)r.getPartByName("ListEmail")).getComponentCount()>0){
				emailSelected=0;
				((JList)r.getPartByName("ListEmail")).setSelectedIndex(0);
			}
			else emailSelected=-1;
		}
		tEmail.setText("");
	}
	
/** Supprime le num&eacute;ro de portable s&eacute;lectionn&eacute;.
 */	
	public void suppPortable(){
		portableSelected=((JList)r.getPartByName("ListPortable")).getSelectedIndex();
		if (portableSelected>=0){
			agenda.suppressionPortable(listeUtilisateurs,utilisateurSelected,portableSelected);
			listePortable.remove(portableSelected);
			((JList)r.getPartByName("ListPortable")).setListData(listePortable);
			if (((JList)r.getPartByName("ListPortable")).getComponentCount()>0){
				portableSelected=0;
				((JList)r.getPartByName("ListPortable")).setSelectedIndex(0);
			}
			else portableSelected=-1;
		}
		tPortable.setText("");
		
	}

/** Ajoute une adresse postale.
 */	
	public void addPostal(){
		String[] liste = new String[6];
		boolean[] vListe = new boolean[6];
		
		if (utilisateurSelected>=0){
			liste[0]=tNum.getText();
			liste[1]=tRue.getText();
			liste[2]=tVille.getText();
			liste[3]=tCode.getText();
			liste[4]=tTelephone.getText();
			liste[5]=tFax.getText();
		
			vListe[0]=cNumRue.isSelected();
			vListe[1]=cRue.isSelected();
			vListe[2]=cVille.isSelected();
			vListe[3]=cCodePostal.isSelected();
			vListe[4]=cTelephone.isSelected();
			vListe[5]=cFax.isSelected();
			
			if (liste[0].length()>0 || liste[1].length()>0 || liste[2].length()>0 || liste[3].length()>0 || liste[4].length()>0 || liste[5].length()>0){
				agenda.addAdresse(listeUtilisateurs,utilisateurSelected,new POSTAL(liste,vListe));
			}
		}
	}
	
/** Modifie les donn&eacute;es concernant un utilisateur.
 */	
	public void modif(){
		agenda.modifUtilisateur(listeUtilisateurs,utilisateurSelected,tNom.getText(),tPrenom.getText(),tLogin.getText(),tPassWord.getText());
		lUtilisateurs.setElementAt(tNom.getText()+" "+tPrenom.getText(),utilisateurSelected);
		((JList)r.getPartByName("ListUtilisateurs")).setListData(lUtilisateurs);
	}

/** Ajoute un num&eacute;ro de portable.
 */		
	public void addPortable(){
		if (tPortable.getText().length()>0 && utilisateurSelected>=0){
			agenda.addPortable(listeUtilisateurs,utilisateurSelected,new PORTABLE(cPortable.isSelected(),tPortable.getText()));
			listePortable.add(tPortable.getText());
			((JList)r.getPartByName("ListPortable")).setListData(listePortable);
			cPortable.setSelected(false);
		}
		tPortable.setText("");
	}
	

/** Ajoute une adresse e-mail.
 */	
 	public void addEmail(){
		if (tEmail.getText().length()>0 && utilisateurSelected>=0){
			agenda.addEmail(listeUtilisateurs,utilisateurSelected,new E_MAIL(cEmail.isSelected(),tEmail.getText()));
			listeEmail.add(tEmail.getText());
			((JList)r.getPartByName("ListEmail")).setListData(listeEmail);
			cEmail.setSelected(false);
		}
		tEmail.setText("");
	}


/** Configuration la fen&ecirc;tre pour l'ajout d'un nouvel utilisateur.
 */		
	public void nouveau(){
		nouveau=true;
		lastId=agenda.getLastId();
		bAjouter.setVisible(true);
		bModifier.setVisible(false);
		bSupprimer.setVisible(false);
		((Panel)r.getPartByName("PanelInfo")).setVisible(false);
		removeAll();
		((TextField)r.getPartByName("TextFieldID")).setText(""+(lastId+1));
	}
	
/** Ajoute un nouvel utilisateur.
 */		
	public void ajouter(){
		if (nouveau){
			if (tLogin.getText().length()>0 && tPassWord.getText().length()>0 && tNom.getText().length()>0 && tPrenom.getText().length()>0 ){
				UTILISATEUR newUtil;
				if(utilisateurs==1){
					newUtil=agenda.rechercheAdmin(tLogin.getText());
					if (newUtil==null){
						newUtil=agenda.rechercheLecteur(tLogin.getText());
						if (newUtil==null){
							ADMINISTRATEUR newAdmin=new ADMINISTRATEUR();
							newAdmin.setId(lastId+1);
							agenda.setLastId(lastId+1);
							newAdmin.modif(tNom.getText(),tPrenom.getText(),tLogin.getText(),tPassWord.getText());
							listeUtilisateurs=agenda.addAdministrateur(newAdmin);
							
							afficheListe(listeUtilisateurs);
							nouveau=false;
							((Panel)r.getPartByName("PanelInfo")).setVisible(true);
							bAjouter.setVisible(false);
							bSupprimer.setVisible(true);
							bModifier.setVisible(true);
						}
						else {
							Global.msgErreur("Ce login est deja existant",false);
							tLogin.setText("");
						}
					}
					else {
						Global.msgErreur("Ce login est deja existant",false);
						tLogin.setText("");
					}
				}
				else if(utilisateurs==2){
					newUtil=agenda.rechercheAdmin(tLogin.getText());
					if (newUtil==null){
						newUtil=agenda.rechercheLecteur(tLogin.getText());
						if (newUtil==null){
							LECTEUR newLecteur=new LECTEUR();
							newLecteur.setId(lastId+1);
							agenda.setLastId(lastId+1);
							newLecteur.modif(tNom.getText(),tPrenom.getText(),tLogin.getText(),tPassWord.getText());
							listeUtilisateurs=agenda.addLecteur(newLecteur);
							
							afficheListe(listeUtilisateurs);
							nouveau=false;
							((Panel)r.getPartByName("PanelInfo")).setVisible(true);
							bAjouter.setVisible(false);
							bSupprimer.setVisible(true);
							bModifier.setVisible(true);
						}
						else {
							Global.msgErreur("Ce login est deja existant",false);
							tLogin.setText("");
						}
					}
					else {
						Global.msgErreur("Ce login est deja existant",false);
						tLogin.setText("");
					}
				}
			}
		}
	}
	
/** Modifie une adresse postale.
 */
	public void modPostal(){
		if (indexAdresse>=0){
			agenda.suppressionAdresse(listeUtilisateurs,utilisateurSelected,indexAdresse);

			String[] liste = new String[6];
			boolean[] vListe = new boolean[6];
		
			if (utilisateurSelected>=0){
				liste[0]=tNum.getText();
				liste[1]=tRue.getText();
				liste[2]=tVille.getText();
				liste[3]=tCode.getText();
				liste[4]=tTelephone.getText();
				liste[5]=tFax.getText();
			
				if (liste[0].length()>0)vListe[0]=cNumRue.isSelected();
				if (liste[1].length()>0)vListe[1]=cRue.isSelected();
				if (liste[2].length()>0)vListe[2]=cVille.isSelected();
				if (liste[3].length()>0)vListe[3]=cCodePostal.isSelected();
				if (liste[4].length()>0)vListe[4]=cTelephone.isSelected();
				if (liste[5].length()>0)vListe[5]=cFax.isSelected();
				
				if (liste[0].length()>0 || liste[1].length()>0 || liste[2].length()>0 || liste[3].length()>0 || liste[4].length()>0 || liste[5].length()>0){
					agenda.addAdresse(listeUtilisateurs,utilisateurSelected,new POSTAL(liste,vListe));
				}
			}
			removePostal();
			affichePostal(indexAdresse);
		}
	}

/** Permet de rendre la frame visible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}
