package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Premi&egrave;re fen&ecirc;tre affich&eacute;e lors de l'execution de l'application.
 */
public class fInvite extends MyFrame{
	public boolean administrateur=false;
	public boolean local=true;
	public String login;
	public String password;
	public AGENDA agenda;
	public String sagenda;
	Renderer r;
	Frame f;
	
/** Cr&eacute;ation de l'instance de la fen&ecirc;tre.
 * @param a le nom du fichier de configuration.
 */
	public fInvite(String a){
		sagenda=a;

		r=new Renderer();
		r.renderUIML("smart4.uiml");
		f=(Frame)r.getPartByName("framefInvite");

		JRadioButton bAdmin=(JRadioButton)r.getPartByName("ButtonRadioAdministrateur");	
		bAdmin.addActionListener(new smart4ActionAdapter(this,3));
		JRadioButton bLecteur=(JRadioButton)r.getPartByName("ButtonRadioLecteur");
		bLecteur.addActionListener(new smart4ActionAdapter(this,4));
		JRadioButton bLocal=(JRadioButton)r.getPartByName("ButtonRadioLocal");
		bLocal.addActionListener(new smart4ActionAdapter(this,5));
		JRadioButton bDistant=(JRadioButton)r.getPartByName("ButtonRadioDistant");
		bDistant.addActionListener(new smart4ActionAdapter(this,6));

		JButton bOk=(JButton)r.getPartByName("ButtonOk");
		bOk.addActionListener(new smart4ActionAdapter(this,1));
		JButton bQuitter=(JButton)r.getPartByName("ButtonQuitter");
		bQuitter.addActionListener(new smart4ActionAdapter(this,2));
	}
	
/** D&eacute;finit si l'utilisateur connect&eacute; est un administrateur.
 * @param b Vrai si l'utilisateur est un administrateur, faux sinon.
 */
 	public void setAdmin(boolean b){
		administrateur=b;
	}
	
/** D&eacute;finit si l'utilisateur est connect&eacute; en local.
 * @param b Vrai si l'utilisateur est connect&eacute; en local, faux sinon.
 */
	public void setLocal(boolean b){
		local=b;
	}
	
/** V&eacute;rifie que l'utilisateur est un administrateur.
 * @return Vrai si l'utilisateur est un administrateur, faux sinon.
 */
	public boolean getAdmin(){
		return administrateur;
	}
	
/** V&eacute;rifie que l'utilisateur est connect&eacute; en local.
 * @return Vrai si l'utilisateur est connect&eacute; en local, faux sinon.
 */
	public boolean getLocal(){
		return local;
	}
	
/** R&eacute;cup&egrave;re la valeur du login de l'utilisateur.
 * @return la valeur du login.
 */	
	public String getLogin(){
		return login;
	}
	
/** D&eacute;termine la valeur du login de l'utilisateur.
 * @param s la nouvelle valeur du login.
 */	
	public void setLogin(String s){
		login=s;
	}
	
/** Valide la saisie de l'utilisateur.
 * Si la saisie est correcte, la fen&ecirc;tre suivante s'affiche.
 * Sinon, un message d'erreur appara&icirc;t.
 */
	public void ok(){
		boolean autorisation=false;
		FileReader fTest;
		boolean resultat=false;
		
		login=((TextField)r.getPartByName("TextFieldLogin")).getText();
		password=((TextField)r.getPartByName("TextFieldPassword")).getText();
		
		//Creation de l'instance agenda
		agenda = new AGENDA(sagenda,local);
			
		if (local){
		//Creation des fichiers agd si necessaire
			try{
				fTest=new FileReader(AGENDA.fRepertoire()+"/"+AGENDA.fAdmin()+"."+AGENDA.AGD);
				fTest.close();
				fTest=new FileReader(AGENDA.fRepertoire()+"/"+AGENDA.fLecteur()+"."+AGENDA.AGD);
				fTest.close();
				fTest=new FileReader(AGENDA.fRepertoire()+"/"+AGENDA.fCalendrier()+"."+AGENDA.AGD);
				fTest.close();
			}
			catch (FileNotFoundException e){
				agenda.creation();
			}
			catch (Exception e2){}
		}
		//Chargement de la base
		resultat=agenda.load();		
		if (resultat){
			if (administrateur){
				autorisation=agenda.rechercheAutorisationAdmin(login,password);
				if(!autorisation) Global.msgErreur("Vous n'etes pas autorises a vous connecter en tant qu'administrateur!",false);
				else {
					setVisible(false);
					((TextField)r.getPartByName("TextFieldLogin")).setText("");
					((TextField)r.getPartByName("TextFieldPassword")).setText("");
					new fMain(agenda,administrateur,local,this);
				}
			}
			else {
				autorisation=agenda.rechercheAutorisationLecteur(login,password);
				if(!autorisation) Global.msgErreur("Vous n'etes pas autorises a vous connecter",false);
				else {
					setVisible(false);
					((TextField)r.getPartByName("TextFieldLogin")).setText("");
					((TextField)r.getPartByName("TextFieldPassword")).setText("");
					new fMain(agenda,administrateur,local,this);
				}
			}
		}
	}
	
/** Permet de mettre fin &agrave; l'application.
 */
	public void quit(){
		if(administrateur){
			try{
				File tmp=new File(AGENDA.fRepertoire()+"/"+AGENDA.SMART+"."+AGENDA.ACS);
				tmp.delete();
			}
			catch (Exception e2){
				Global.msgErreur("fInvite.quit : "+e2.getMessage(),true);
			}
		}
		setVisible(false);
		if (AGENDA.modif) new fSave(agenda);
		else System.exit(0);
	}

/** Permet de rendre la frame visible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}