package SmartAgenda.Interface;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

import Outils.*;
import SmartAgenda.MyAwt.*;
import SmartAgenda.Moteur.*;
import com.harmonia.renderer.Renderer;

/** Fen&ecirc;tre permettant de manipuler l'agenda.
 */
public class fMain extends MyFrame{
	private fInvite pere;
	public boolean administrateur;
	public boolean local;
	private int choixAffiche=1;
	
	AGENDA agenda;
	ADMINISTRATEUR ad;
	Renderer r;
	Frame f;
	
/** Cr&eacute;ation de l'instance de la Fen&ecirc;tre.
 * @param a l'agenda.
 * @param admin vrai si l'utilisateur est un administrateur, faux sinon.
 * @param l vrai si l'utilisateur travail en local, faux sinon.
 * @param p le p&egrave;re de la Fen&ecirc;tre.
 */
	public fMain (AGENDA a, boolean admin, boolean l, fInvite p){
		agenda=a;
		pere=p;
		administrateur=admin;
		local=l;
		ad=agenda.rechercheAdmin(p.getLogin());
		byte[] data;
		String s;
		String delim = new String(Global.CRLF);
		StringTokenizer st;
		int limite;
		String nom;
		String prenom;
		long time;
		long currentTime = System.currentTimeMillis();

		r=new Renderer();
		if(administrateur){
			r.renderUIML("smart6.uiml");
		}
		else{
			r.renderUIML("smart6bis.uiml");
		}
		f=(Frame)r.getPartByName("framefMain");

		JRadioButton bAdmin=(JRadioButton)r.getPartByName("ButtonRadioAdmin");
		bAdmin.addActionListener(new smart6ActionAdapter(this,7));
		JRadioButton bLec=(JRadioButton)r.getPartByName("ButtonRadioLec");
		bLec.addActionListener(new smart6ActionAdapter(this,8));
		JRadioButton bUtil=(JRadioButton)r.getPartByName("ButtonRadioUtil");
		bUtil.addActionListener(new smart6ActionAdapter(this,9));
		JRadioButton bPH=(JRadioButton)r.getPartByName("ButtonRadioPH");
		bPH.addActionListener(new smart6ActionAdapter(this,10));

		JButton bAfficher=(JButton)r.getPartByName("ButtonAfficher");
		bAfficher.addActionListener(new smart6ActionAdapter(this,1));
		if(administrateur){
			JButton bGenererXML=(JButton)r.getPartByName("ButtonGenererXML");
			bGenererXML.addActionListener(new smart6ActionAdapter(this,2));
			JButton bChargerXML=(JButton)r.getPartByName("ButtonChargerXML");		/*ATTENTION*/
			bChargerXML.addActionListener(new smart6ActionAdapter(this,11));		/*ATTENTION*/
		}
		JButton bCharger=(JButton)r.getPartByName("ButtonCharger");
		bCharger.addActionListener(new smart6ActionAdapter(this,3));
		if(administrateur){
			JButton bSauver=(JButton)r.getPartByName("ButtonSauver");
			bSauver.addActionListener(new smart6ActionAdapter(this,4));
		}
		JButton bQuitter=(JButton)r.getPartByName("ButtonQuitter");
		bQuitter.addActionListener(new smart6ActionAdapter(this,5));
		JButton bRetour=(JButton)r.getPartByName("ButtonRetour");
		bRetour.addActionListener(new smart6ActionAdapter(this,6));

		if (administrateur && local){
			try{
				FileInputStream fTest=new FileInputStream(agenda.fRepertoire()+"/"+agenda.SMART+"."+AGENDA.ACS);
				data = new byte[fTest.available()];
		 		fTest.read(data);
				fTest.close();
				s = new String(data);
				st=new StringTokenizer(s,delim);
				limite = st.countTokens();
				if (limite==3){
					nom=st.nextToken();
					prenom=st.nextToken();
					time=(new Long(st.nextToken())).longValue();
					if (currentTime-time>agenda.getTtl()){
						try{
							FileWriter fNew=new FileWriter(agenda.fRepertoire()+"/"+agenda.SMART+"."+AGENDA.ACS,false);
							fNew.write(ad.getNom()+Global.CRLF+ad.getPrenom()+Global.CRLF+System.currentTimeMillis());
							fNew.close();
						}
						catch (IOException e){
							Global.msgErreur ("fMain.<init> : "+e.getMessage(),false);
						}
					}
					else{
						Global.msgErreur (prenom+" "+nom+" est deja connecte(e), vous accedez en lecture a l'agenda.",false);
						administrateur=false;
					}
				}
				else{
					try{
							File tmp=new File(agenda.fRepertoire()+"/"+agenda.SMART+"."+AGENDA.ACS);
							tmp.delete();
						}
					catch (Exception e2){}
					Global.msgErreur ("Le fichier de controle est incoherent,veuillez contacter les autres administrateurs.",true);
				}
			}
			catch (IOException e1){
				try{
						FileWriter fNew=new FileWriter(agenda.fRepertoire()+"/"+agenda.SMART+"."+AGENDA.ACS,false);
						fNew.write(ad.getNom()+Global.CRLF+ad.getPrenom()+Global.CRLF+System.currentTimeMillis());
						fNew.close();
					}
				catch (IOException e3){
					Global.msgErreur ("fMain.<init> : "+e3.getMessage(),true);
				}
			}
		}
	}
	
/** R&eacute;cup&eacute;re le choix d'affichage de l'utilisateur.
 * @return le choix d'affichage de l'utilisateur.
 */
	public int getChoixAffiche(){
		return choixAffiche;
	}

/** S&eacute;lectionne le choix d'affichage de l'utilisateur.
 * @param i le choix d'affichage de l'utilisateur.
 */
	public void setChoixAffiche(int i){
		choixAffiche=i;
	}

/** G&eacute;n&eacute;re les fichiers xml.
 */
	public void xml(){
		agenda.save(true);
	}

/** Charge les fichiers xml.
 */
	public void loadXML(){							/*ATTENTION ne fonctionne pas*/
//		agenda.loadXML();
	}
	
/** Charge en m&eacute;moire l'agenda.
 */
	public void load(){
		boolean ok=agenda.load();
		if(ok) Global.msgErreur("Chargement effectuee.",false);
	}
	
/** Permet de revenir &agrave; la fentre pr&eacute;c&eacute;dente.
 */
	public void back(){
		setVisible(false);
		pere.setVisible(true);
	}
	
/** Sauvegarde les modifications.
 */
	public void save(){
		if (agenda.modif) agenda.save(false);
	}
	
/** Permet de mettre fin &agrave; l'application.
 */
	public void quit(){
		if(administrateur){
			try{
				File tmp=new File(agenda.fRepertoire()+"/"+agenda.SMART+"."+AGENDA.ACS);
				tmp.delete();
			}
			catch (Exception e2){
				Global.msgErreur("fMain.quit : "+e2.getMessage(),true);
			}
		}
		setVisible(false);
		Dimension d=new Dimension(getSize());
		if (agenda.modif) new fSave(agenda);
		else System.exit(0);
	}

/** Affiche l'agenda en fonction du choix de l'utilisateur.
 */
	public void affiche(){
		switch (choixAffiche){
			case 1 : new fAfficheUtil(choixAffiche,administrateur,agenda,this);break;
			case 2 : new fAfficheUtil(choixAffiche,administrateur,agenda,this);break;
			case 3 : new fAfficheUtil(choixAffiche,administrateur,agenda,this);break;
			case 4 : new fAfficheCal(administrateur,agenda,this);agenda.affichePlageHoraire(administrateur);break;
			default: break;
		}
	}

/** Permet de rendre la frame visible.
 */
	public void setVisible(boolean b){
		f.setVisible(b);
	}

}
		