package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;

import Outils.*;
import SmartAgenda.Interface.*;
import SmartAgenda.Net.*;


/** Classe permettant la gestion de l'agenda. */
public class AGENDA {
/** Variable indiquant si une modification a eu lieu.*/
	public static boolean modif =false;
/** Nom par d&eacute;faut du repertoire de travail. */ 
	public static final String REP = "smart";
/** Nom par d&eacute;faut du fichier contenant la liste des administrateurs. */
	public static final String ADM = "admin";
/** Nom par d&eacute;faut du fichier contenant la liste des lecteurs. */
	public static final String LEC = "lecteur";
/** Nom par d&eacute;faut du fichier contenant la liste des plages horaires. */
	public static final String CAL = "calendrier";
/** Nom par d&eacute;faut du fichier de configuration. */
	public static final String SMART = "smartAgenda";
/** Extention des fichiers contenant les informations de l'agenda.*/
	public static final String AGD = "agd";
/** Extention des fichiers xml.*/
	public static final String XML = "xml";
/* Extention des fichiers de sauvegardes (permet ainsi de r&eacute;cup&eacute;rer les donn&eacute;es perdues suite &agrave; un plantage.*/
	private static final String OLD = "old";
/** Extention des fichiers de configuration.*/
	public static final String INI = "ini";
/** Extention du fichier de gestion d'acc&egrave;s. */
	public static final String ACS = "acs";
/** Temps par d&eacute;faut en millisecondes d'une connexion pour un administrateur. 

TTL = Time To Live.*/
	public static final long TTL = 1200000;
/** Adresse du seveur distante. */
	public static final String URI = "http://127.0.0.1:80";
/** Chemin du r&eacute;pertoire de la connexion distante. */
	public static final String REPDIST = "smartagenda";
	
/** Nom du fichier permettant la copie du calendrier sur le serveur. */
	public static final String CGICAL = "SaveCal.bat";
/** Nom du fichier permettant la copie du fichier des lecteurs sur le serveur. */
	public static final String CGILEC = "SaveLec.bat";
/** Nom du fichier permettant la copie du fichier des admin sur le serveur. */
	public static final String CGIADM = "SaveAdmin.bat";
/** Nom du fichier du calendrier plac&eacute; sur le serveur. */
	public static final String NETCAL = "calendrier";
/** Nom du fichier des lecteurs plac&eacute; sur le serveur. */
	public static final String NETLEC = "lecteur";
/** Nom du fichier des administrateurs plac&eacute; sur le serveur. */
	public static final String NETADM = "admin";
	
	private static String repertoire = AGENDA.REP;
	private static String ficA = AGENDA.ADM;
	private static String ficL = AGENDA.LEC;
	private static String ficC = AGENDA.CAL;
	private static String netA = AGENDA.NETADM;
	private static String netL = AGENDA.NETLEC;
	private static String netC = AGENDA.NETCAL;
	private static String cgiA = AGENDA.CGIADM;
	private static String cgiL = AGENDA.CGILEC;
	private static String cgiC = AGENDA.CGICAL;
	private static String repDist = AGENDA.REPDIST;
	
	private static String sagenda = AGENDA.SMART;
	private static long ttl=AGENDA.TTL;
	private static String url=AGENDA.URI;
	private static int lastId = 0;
	private FileInputStream ficIni;

/** Liste des plages horaires.*/
	public Vector m_Plage_Horaire;
/** Liste des lecteurs.*/
	public Vector m_Lecteur;
/** Liste des administrateurs.*/
	public Vector m_Administrateur;
	private boolean append=true;
	private boolean local;
/* CONSTRUCTEURS */

/** Cr&eacute;ation d'une nouvelle instance de la classe.
 * @param ini nom du fichier de configuration
 */
	public AGENDA(String ini,boolean l){
		byte[] data;
		String fichier;
		local=l;
		sagenda = ini;
		fichier=sagenda+"."+AGENDA.INI;
		
		try {		 	
		 	ficIni= new FileInputStream(fichier);
		 	data = new byte[ficIni.available()];
		 	ficIni.read(data);
			rechercheIni(new String(data));
		}
		catch (FileNotFoundException e){
			Global.msgErreur ("Execution impossible : "+fichier+" non trouve.",true);
		}
		catch (IOException e2){
			Global.msgErreur ("Execution impossible : lecture de "+fichier+" impossible.",true);
		}
		if (!local){
			try{
				String s=DataURLAccess.readData(url+"/"+repDist+"/"+"sagenda.ini");
				rechercheIni(s);
			}
			catch (Exception e){
				Global.msgErreur ("Execution impossible : impossible de lire "+url+"/"+repDist+"/"+"sagenda.ini.",true);
			}
		}
		
		m_Plage_Horaire = new Vector();
		m_Lecteur = new Vector();
		m_Administrateur = new Vector();
	}
	
/* RECHERCHES DES PARAMETRES NECESSAIRE AU BON FONCTIONNEMENT */
/** Permet de charger les param&egrave;tres de configuration.
 * @param data le nom du fichier de configuration
 */
	private void rechercheIni (String data){ 
		String s = new String(data);
		String delim = new String(Global.CRLF);
		StringTokenizer st=new StringTokenizer(s,delim);
		int limite = st.countTokens();
		String[] contenu = new String[limite];

		for(int i=0;i<limite;i++){
			try{
				contenu[i]=st.nextToken();
			}
			catch (NoSuchElementException e){
				contenu[i]="";
			}
		}
		
		for(int i=0;i<(limite-1);i++){
			if (contenu[i].compareTo("[REPERTOIRE]")==0){
				repertoire = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[URL]")==0){
				url = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[REP DISTANT]")==0){
				repDist = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[ADMIN]")==0){
				ficA = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[LECTEUR]")==0){
				ficL = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[CALENDRIER]")==0){
				ficC = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[TTL]")==0){
				ttl = (new Long(contenu[i+1])).longValue();
				i++;
			}
			else if (contenu[i].compareTo("[LAST ID]")==0){
				lastId = (new Integer(contenu[i+1])).intValue();
				i++;
			}
			else if (contenu[i].compareTo("[CGICAL]")==0){
				cgiC = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[CGILEC]")==0){
				cgiL = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[CGIADM]")==0){
				cgiA = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[NETLEC]")==0){
				netL = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[NETADM]")==0){
				netA = contenu[i+1];
				i++;
			}
			else if (contenu[i].compareTo("[NETCAL]")==0){
				netC = contenu[i+1];
				i++;
			}
		}
	}
	
/* CREATION DES FICHIERS */

/** Cr&eacute;ation du fichier de configuration.
 */
	public void creation() {
		FileWriter fAdmin;
		FileWriter fLecteur;
		FileWriter fCal;
		File fRep;
		
		modif=true;
		try{
			fRep=new File(repertoire);
			if (fRep.exists()==false){fRep.mkdir();};
		}
		catch (Exception e)
		{
			Global.msgErreur ("AGENDA.creation : "+e.getMessage(),true);
		}
		try {
			fAdmin = new FileWriter(repertoire+"/"+ficA+"."+AGENDA.AGD,false);
			fAdmin.write ("<AGENDA>"+Global.CRLF);
			fAdmin.write("<ADMIN>");
			fAdmin.close();
			}
		catch (IOException e) {
			Global.msgErreur ("AGENDA.creation : "+e.getMessage(),true);
		}
		try {
			fLecteur = new FileWriter(repertoire+"/"+ficL+"."+AGENDA.AGD,false);
			fLecteur.write ("<AGENDA>"+Global.CRLF);
			fLecteur.write("<LEC>");
			fLecteur.close();
			}
		catch (IOException e) {
			Global.msgErreur ("AGENDA.creation : "+e.getMessage(),true);
		}
		try {
			fCal = new FileWriter(repertoire+"/"+ficC+"."+AGENDA.AGD,false);
			fCal.write ("<AGENDA>"+Global.CRLF);
			fCal.write("<CAL>");
			fCal.close();
		}
		catch (IOException e) {
			Global.msgErreur ("AGENDA.creation : "+e.getMessage(),true);
		}
		Global.msgErreur("Il n'existe pour le moment qu'un login d'administrateur : Admin",false);
		m_Administrateur.addElement(new ADMINISTRATEUR("0","A","A","Admin","Admin"));
	}

/* chargement de la base */

/** Chargement de l'agenda en m&eacute;moire.
 */
	public boolean load(){
		FileInputStream fAdmin;
		FileInputStream fLecteur;
		FileInputStream fCal;
		String fichier;
		byte[] buffer;
		String buf;
		String delim = new String(Global.CRLF);
		StringTokenizer st;
		String agenda;
		String tag;
		int limite; 
		boolean ok=true;
		append=false;
			
		try{
			if (local){
				fichier=repertoire+"/"+ficA+"."+AGENDA.AGD;		/*ATTENTION AGENDA.XML*/
				fAdmin = new FileInputStream(fichier);
				buffer = new byte[fAdmin.available()];
				fAdmin.read(buffer);
				buf=new String(buffer);
				fAdmin.close();
			}
			else{
				fichier=url+"/"+repDist+"/"+netA+"."+AGENDA.AGD;
				try{
					buf=DataURLAccess.readData(fichier);
				}
				catch (Exception ex){
					return false;
				}
			}
				
			st=new StringTokenizer(buf,delim);
			limite= st.countTokens();
			if (limite>0){
				agenda = st.nextToken();
				if (agenda.compareTo("<AGENDA>")==0){
					tag = st.nextToken();
					if (tag.compareTo("<ADMIN>")==0){
						m_Administrateur.removeAllElements();
						for(int i=0;i<limite-2;i++){
							m_Administrateur.addElement(new ADMINISTRATEUR(st.nextToken()));
						}
					}
					else{
						Global.msgErreur(ficA+"."+AGENDA.AGD+" : fichier administrateur incorrect.",false);
					}
				}
				else{
					Global.msgErreur(ficA+"."+AGENDA.AGD+" : fichier agenda incorrect.",false);
				}
			}
			else{
				Global.msgErreur(ficA+"."+AGENDA.AGD+" : fichier vide.",false);
			}
			if (m_Administrateur.size()==0){
				Global.msgErreur("Il n'existe pour le moment qu'un login d'administrateur : Admin",false);
				m_Administrateur.addElement(new ADMINISTRATEUR("0","A","A","Admin","Admin"));
			}
		}
		catch (IOException e1){
			Global.msgErreur("AGENDA.load IOException : "+e1.getMessage(),true);
		}
		agenda="";
		tag="";
		try{
			if(local){
				fichier=repertoire+"/"+ficL+"."+AGENDA.AGD;
				fLecteur = new FileInputStream(fichier);
				buffer = new byte[fLecteur.available()];
				fLecteur.read(buffer);
				buf=new String(buffer);
				fLecteur.close();
			}
			else{
				try{
					fichier=url+"/"+repDist+"/"+netL+"."+AGENDA.AGD;
					buf=DataURLAccess.readData(fichier);
				}
				catch (Exception ex){
					return false;
				}
			}
			st=new StringTokenizer(buf,delim);
			limite= st.countTokens();
			if (limite>0){
				agenda = st.nextToken();
				if (agenda.compareTo("<AGENDA>")==0){
					tag = st.nextToken();
					if (tag.compareTo("<LEC>")==0){
						m_Lecteur.removeAllElements();
						for(int i=0;i<limite-2;i++){
							m_Lecteur.addElement(new LECTEUR(st.nextToken()));
						}
					}
					else{
						Global.msgErreur(ficL+"."+AGENDA.AGD+" : fichier lecteur incorrect.",false);
					}
				}
				else{
					Global.msgErreur(ficL+"."+AGENDA.AGD+" : fichier agenda incorrect.",false);
				}
			}
			else{
				Global.msgErreur(ficL+"."+AGENDA.AGD+" : fichier vide.",false);
			}
		}
		catch (IOException e1){
			Global.msgErreur("AGENDA.load IOException : "+e1.getMessage(),false);
		}
		agenda = "";
		tag = "";
		try{
			if (local){
				fichier=repertoire+"/"+ficC+"."+AGENDA.AGD;
				fCal = new FileInputStream(fichier);
				buffer = new byte[fCal.available()];
				fCal.read(buffer);
				buf=new String(buffer);
				fCal.close();
			}
			else{
				try{
					fichier=url+"/"+repDist+"/"+netC+"."+AGENDA.AGD;
					buf=DataURLAccess.readData(fichier);
				}
				catch (Exception ex){
					return false;
				}
			}

			st=new StringTokenizer(buf,delim);
			limite= st.countTokens();
			if (limite>0){
				agenda = st.nextToken();
				if (agenda.compareTo("<AGENDA>")==0){
					tag = st.nextToken();
					if (tag.compareTo("<CAL>")==0){
						m_Plage_Horaire.removeAllElements();
						for(int i=0;i<limite-2;i++){
							m_Plage_Horaire.addElement(new PLAGE_HORAIRE(st.nextToken(),m_Administrateur,m_Lecteur));
						}
					}
					else{
						Global.msgErreur(ficC+"."+AGENDA.AGD+" : fichier calendrier incorrect.",false);
					}
				}
				else{
					Global.msgErreur(ficC+"."+AGENDA.AGD+" : fichier agenda incorrect.",false);
				}
			}
			else{
				Global.msgErreur(ficC+"."+AGENDA.AGD+" : fichier vide.",false);
			}
		}
		catch (IOException e1){
			Global.msgErreur("AGENDA.load IOException : "+e1.getMessage(),false);
		}
		return true;
	}

/** Chargement de l'agenda en m&eacute;moire  partir des fichier XML.
 */
//	public boolean loadXML(){						/*ATTENTION ne fonctionne pas*/
//		FileInputStream fAdmin;
//		FileInputStream fLecteur;
//		FileInputStream fCal;
//		String fichier;
//		byte[] buffer;
//		String buf;
//		String delim = new String(Global.CRLF);
//		StringTokenizer st;
//		String agenda;
//		String tag;
//		int limite; 
//		boolean ok=true;
//		append=false;
//			
//		try{
//			if (local){
//				fichier=repertoire+"/"+ficA+"."+AGENDA.XML;
//				fAdmin = new FileInputStream(fichier);
//				buffer = new byte[fAdmin.available()];
//				fAdmin.read(buffer);
//				buf=new String(buffer);
//				fAdmin.close();
//			}
//			else{
//				fichier=url+"/"+repDist+"/"+netA+"."+AGENDA.XML;
//				try{
//					buf=DataURLAccess.readData(fichier);
//				}
//				catch (Exception ex){
//					return false;
//				}
//			}
//				
//			st=new StringTokenizer(buf,delim);
//			limite= st.countTokens();
//			if (limite>0){
//				agenda = st.nextToken();
//				if (agenda.compareTo("<AGENDA>")==0){
//					tag = st.nextToken();
//					if (tag.compareTo("<ADMIN>")==0){
//						m_Administrateur.removeAllElements();
//						for(int i=0;i<limite-2;i++){
//							m_Administrateur.addElement(new ADMINISTRATEUR(st.nextToken(),true));
//						}
//					}
//					else{
//						Global.msgErreur(ficA+"."+AGENDA.XML+" : fichier administrateur incorrect.",false);
//					}
//				}
//				else{
//					Global.msgErreur(ficA+"."+AGENDA.XML+" : fichier agenda incorrect.",false);
//				}
//			}
//			else{
//				Global.msgErreur(ficA+"."+AGENDA.XML+" : fichier vide.",false);
//			}
//			if (m_Administrateur.size()==0){
//				Global.msgErreur("Il n'existe pour le moment qu'un login d'administrateur : Admin",false);
//				m_Administrateur.addElement(new ADMINISTRATEUR("0","A","A","Admin","Admin"));
//			}
//		}
//		catch (IOException e1){
//			Global.msgErreur("AGENDA.load IOException : "+e1.getMessage(),true);
//		}
//		agenda="";
//		tag="";
//		try{
//			if(local){
//				fichier=repertoire+"/"+ficL+"."+AGENDA.XML;
//				fLecteur = new FileInputStream(fichier);
//				buffer = new byte[fLecteur.available()];
//				fLecteur.read(buffer);
//				buf=new String(buffer);
//				fLecteur.close();
//			}
//			else{
//				try{
//					fichier=url+"/"+repDist+"/"+netL+"."+AGENDA.XML;
//					buf=DataURLAccess.readData(fichier);
//				}
//				catch (Exception ex){
//					return false;
//				}
//			}
//			st=new StringTokenizer(buf,delim);
//			limite= st.countTokens();
//			if (limite>0){
//				agenda = st.nextToken();
//				if (agenda.compareTo("<AGENDA>")==0){
//					tag = st.nextToken();
//					if (tag.compareTo("<LEC>")==0){
//						m_Lecteur.removeAllElements();
//						for(int i=0;i<limite-2;i++){
//							m_Lecteur.addElement(new LECTEUR(st.nextToken(),true));
//						}
//					}
//					else{
//						Global.msgErreur(ficL+"."+AGENDA.XML+" : fichier lecteur incorrect.",false);
//					}
//				}
//				else{
//					Global.msgErreur(ficL+"."+AGENDA.XML+" : fichier agenda incorrect.",false);
//				}
//			}
//			else{
//				Global.msgErreur(ficL+"."+AGENDA.XML+" : fichier vide.",false);
//			}
//		}
//		catch (IOException e1){
//			Global.msgErreur("AGENDA.load IOException : "+e1.getMessage(),false);
//		}
//		agenda = "";
//		tag = "";
//		try{
//			if (local){
//				fichier=repertoire+"/"+ficC+"."+AGENDA.XML;
//				fCal = new FileInputStream(fichier);
//				buffer = new byte[fCal.available()];
//				fCal.read(buffer);
//				buf=new String(buffer);
//				fCal.close();
//			}
//			else{
//				try{
//					fichier=url+"/"+repDist+"/"+netC+"."+AGENDA.XML;
//					buf=DataURLAccess.readData(fichier);
//				}
//				catch (Exception ex){
//					return false;
//				}
//			}
//
//			st=new StringTokenizer(buf,delim);
//			limite= st.countTokens();
//			if (limite>0){
//				agenda = st.nextToken();
//				if (agenda.compareTo("<AGENDA>")==0){
//					tag = st.nextToken();
//					if (tag.compareTo("<CAL>")==0){
//						m_Plage_Horaire.removeAllElements();
//						for(int i=0;i<limite-2;i++){
//							m_Plage_Horaire.addElement(new PLAGE_HORAIRE(st.nextToken(),m_Administrateur,m_Lecteur,true));
//						}
//					}
//					else{
//						Global.msgErreur(ficC+"."+AGENDA.XML+" : fichier calendrier incorrect.",false);
//					}
//				}
//				else{
//					Global.msgErreur(ficC+"."+AGENDA.XML+" : fichier agenda incorrect.",false);
//				}
//			}
//			else{
//				Global.msgErreur(ficC+"."+AGENDA.XML+" : fichier vide.",false);
//			}
//		}
//		catch (IOException e1){
//			Global.msgErreur("AGENDA.load IOException : "+e1.getMessage(),false);
//		}
//		return true;
//	}

/** Sauvegarde les fichiers au format agd ou xml.
 * @param xml si Vrai, alors les fichiers seront sauvegard&eacute;s au format xml, sinon au format agd
 */
	public void save(boolean xml){
		FileWriter fAdmin;
		FileWriter fLecteur;
		FileWriter fCal;

		if (local ||xml){
			
			if (xml) System.out.println("Sauvegarde des fichiers XML");
			else {
				modif=false;
				System.out.println("Sauvegarde de l'agenda");
			}
			try {
				if (xml) fAdmin = new FileWriter(repertoire+"/"+ficA+"."+AGENDA.XML,append);
				else fAdmin = new FileWriter(repertoire+"/"+ficA+"."+AGENDA.AGD,append);
				if (append==false){
					fAdmin.write ("<AGENDA>"+Global.CRLF);
					fAdmin.write("<ADMIN>");
				}
				saveAdmin(fAdmin,xml);
				if (xml){
					fAdmin.write ("</ADMIN>"+Global.CRLF);
					fAdmin.write("</AGENDA>");
				}
				fAdmin.close();
				}
			catch (IOException e) {
				Global.msgErreur ("AGENDA.save : sauvegarde de "+ficA+" impossible",false);
			}
			try {
				if (xml) fLecteur = new FileWriter(repertoire+"/"+ficL+"."+AGENDA.XML,append);
				else fLecteur = new FileWriter(repertoire+"/"+ficL+"."+AGENDA.AGD,append);
				if (append==false){
					fLecteur.write ("<AGENDA>"+Global.CRLF);
					fLecteur.write("<LEC>");
				}
				if (m_Lecteur.size()>0){
					saveLecteur(fLecteur,xml);
				}
				if (xml){
					fLecteur.write ("</LEC>"+Global.CRLF);
					fLecteur.write("</AGENDA>");
				}
				fLecteur.close();
				}
			catch (IOException e) {
				Global.msgErreur ("AGENDA.save : "+e.getMessage(),false);
			}
			try {
				if (xml) fCal = new FileWriter(repertoire+"/"+ficC+"."+AGENDA.XML,append);
				else fCal = new FileWriter(repertoire+"/"+ficC+"."+AGENDA.AGD,append);
				if (append==false){
					fCal.write ("<AGENDA>"+Global.CRLF);
					fCal.write("<CAL>");
				}
				savePlage_Horaire(fCal,xml);
				if (xml){
					fCal.write ("</CAL>"+Global.CRLF);
					fCal.write("</AGENDA>");
				}
				fCal.close();
			}
			catch (IOException e) {
				Global.msgErreur ("AGENDA.save : "+e.getMessage(),false);
			}
			if (xml) Global.msgErreur("Generation des fichiers XML terminee",false);
			else Global.msgErreur("Sauvegarde terminee",false);
		}
		else{
			boolean resultat=false;
			boolean resFin=true;
			System.out.println("Save distant");
			
			for (int i=0;i<m_Administrateur.size();i++){
				resultat=((ADMINISTRATEUR)m_Administrateur.elementAt(i)).saveDistant((i==0),(i==m_Administrateur.size()-1),url+"/"+cgiA);
				resFin&=resultat;
				if (!resultat){
					Global.msgErreur("Erreur de connection au serveur "+i+"!!!",false);
					break;
				}
			}
			for (int i=0;i<m_Lecteur.size();i++){
				resultat=((LECTEUR)m_Lecteur.elementAt(i)).saveDistant((i==0),(i==m_Lecteur.size()-1),url+"/"+cgiL);
				resFin&=resultat;
				if (!resultat){
					Global.msgErreur("Erreur de connection au serveur !!!",false);
					break;
				}
			}
			for (int i=0;i<m_Plage_Horaire.size();i++){
				resultat=((PLAGE_HORAIRE)m_Plage_Horaire.elementAt(i)).saveDistant((i==0),(i==m_Plage_Horaire.size()-1),url+"/"+cgiC);
				resFin&=resultat;
				if (!resultat){
					Global.msgErreur("Erreur de connection au serveur !!!",false);
					break;
				}
			}
			if(resFin){
				modif=false;
				Global.msgErreur("Sauvegarde distante effectuee.",false);
			}
		}
	}

	private void saveAdmin(FileWriter fic, boolean xml){
		System.out.println("ADM ="+m_Administrateur.size());
		for (int i=0;i<m_Administrateur.size();i++){
			try{
				fic.write(Global.CRLF+"<UTIL>");
				((ADMINISTRATEUR)m_Administrateur.elementAt(i)).save(fic,xml);
				if (xml) fic.write("</UTIL>"+Global.CRLF);
			}
			catch(IOException e){
				Global.msgErreur("AGENDA.saveAdmin : "+e.getMessage(),false);
			}
		}
	}
	
	private void saveLecteur(FileWriter fic, boolean xml){
		System.out.println("LEC ="+m_Lecteur.size());
		for (int i=0;i<m_Lecteur.size();i++){
			try{
				fic.write(Global.CRLF+"<UTIL>");
				((LECTEUR)m_Lecteur.elementAt(i)).save(fic,xml);
				if (xml) fic.write("</UTIL>"+Global.CRLF);
			}
			catch(IOException e){
				Global.msgErreur("AGENDA.saveLecteur : "+e.getMessage(),false);
			}
		}
	}
	
	private void savePlage_Horaire(FileWriter fic, boolean xml){
		System.out.println("PH ="+m_Plage_Horaire.size());
		for (int i=0;i<m_Plage_Horaire.size();i++){
			((PLAGE_HORAIRE)m_Plage_Horaire.elementAt(i)).save(fic,xml);
		}
	}

/** Insertion d'un nouvel administrateur par saisie.
 */
	public void addAdmin(){
		String[] adm;
		String reponse="";
		Vector postal=new Vector();
		Vector autre_email=new Vector();
		Vector autre_portable=new Vector();
		ADMINISTRATEUR admin;
		
		modif=true;
		adm = saisieUtil();
		System.out.print("Une adresse ? (O/N) : ");
		try{
			reponse=Global.readln();
		}
		catch(IOException e){
			reponse="N";
		}
		if((reponse.toUpperCase()).compareTo("O")==0){	
			postal= saisiePostal();
			autre_email = saisieAutreEmail();
			autre_portable = saisieAutrePortable();
		}
			if (adm!=null){
				m_Administrateur=addUtilisateur(m_Administrateur,new ADMINISTRATEUR(adm,postal,autre_email,autre_portable));
			}
	}

/** Insertion d'un nouveau lecteur.
 */	
	public void addLecteur(){
		String[] lecteur;
		String reponse="";
		Vector postal=new Vector();
		Vector autre_email=new Vector();
		Vector autre_portable=new Vector();

		modif=true;
		lecteur= saisieUtil();
		System.out.print("Une adresse ? (O/N) : ");
		try{
			reponse=Global.readln();
		}
		catch(IOException e){
			reponse="N";
		}
		if((reponse.toUpperCase()).compareTo("O")==0){	
			postal= saisiePostal();
			autre_email = saisieAutreEmail();
			autre_portable = saisieAutrePortable();
		}
		if (lecteur!=null){
			m_Lecteur=addUtilisateur(m_Lecteur,new LECTEUR(lecteur,postal,autre_email,autre_portable));
		}
	}

/** Ajout d'un utilisateur dans un vecteur
 */
 	public Vector addUtilisateur(Vector v, UTILISATEUR u){
 		Vector v2=new Vector();
 		int i;
 		boolean verif=false;
 		
 		for(i=0;i<v.size();i++){
			verif=u.plusGrand((UTILISATEUR)v.elementAt(i));
 			if(verif) v2.addElement(v.elementAt(i));
 			else break;
 		}
 		v2.addElement(u);
 		for(int j=i;j<v.size();j++){
 			v2.addElement(v.elementAt(j));
 		}
 		v=v2;
 		return v;
 	}
 		
/** Ajout d'un administrateur dans un vecteur
 */
 	public Vector addAdministrateur(ADMINISTRATEUR u){
 		Vector v2=new Vector();
 		int i;
 		boolean verif=false;
 		
 		modif=true;
 		for(i=0;i<m_Administrateur.size();i++){
			verif=u.plusGrand((ADMINISTRATEUR)m_Administrateur.elementAt(i));
 			if(verif) v2.addElement((ADMINISTRATEUR)m_Administrateur.elementAt(i));
 			else break;
 		}
 		v2.addElement(u);
 		for(int j=i;j<m_Administrateur.size();j++){
 			v2.addElement((ADMINISTRATEUR)m_Administrateur.elementAt(j));
 		}
 		m_Administrateur=v2;
 		return m_Administrateur;
 	}
 	
/** Ajout d'un lecteur dans un vecteur
 */
 	public Vector addLecteur(LECTEUR u){
 		Vector v2=new Vector();
 		int i;
 		boolean verif=false;
 		
 		modif=true;
 		for(i=0;i<m_Lecteur.size();i++){
			verif=u.plusGrand((LECTEUR)m_Lecteur.elementAt(i));
 			if(verif) v2.addElement((LECTEUR)m_Lecteur.elementAt(i));
 			else break;
 		}
 		v2.addElement(u);
 		for(int j=i;j<m_Lecteur.size();j++){
 			v2.addElement((LECTEUR)m_Lecteur.elementAt(j));
 		}
 		m_Lecteur=v2;
 		return m_Lecteur;
 	}
 	
/** Insertion d'une nouvelle plage horaire.
/** @p plage horaire  ajouter.
 */
	public void addPlageHoraire(String[] p,Vector u,Vector id){
		String[] plage;
		Vector lId = id;
		Vector lLecteur=new Vector();
		Vector lURL = u;
		UTILISATEUR util;
		PLAGE_HORAIRE ph;
		String reponse;
		modif=true;
		plage = format(p);
		/*lId = saisiePlageId();*//*lId=new Vector(); lId.addElement("6");*//*ATTENTION temporaire*/

		for(int i=0;i<lId.size();i++){
			util=UTILISATEUR.rechercheUtilisateur(m_Administrateur,(String)lId.elementAt(i));
			if (util!=null){
				lLecteur.addElement(util);
				 }
			else {
				util=UTILISATEUR.rechercheUtilisateur(m_Lecteur,(String)lId.elementAt(i));
				if (util!=null) lLecteur.addElement(util);
				else Global.msgErreur("ID inconnu",false);
			}
		}
		if (plage!=null){
			ph=new PLAGE_HORAIRE(plage,lLecteur,lURL);
			if(!ph.gestionCoherence()){
				Global.msgErreur("ATTENTION : IL EXISTE UNE INCOHERENCE DANS CETTE PLAGE HORAIRE ",false);
			}
			else{
//A TERME : modifier la plage
				if(ph.gestionConflit(m_Plage_Horaire)){
					Global.msgErreur("ATTENTION : IL EXISTE UN CONFLIT AVEC UNE AUTRE PLAGE HORAIRE ",false);
//A TERME : modifier la plage
					System.out.println("VOULEZ VOUS TOUT DE MEME CONSERVER CETTE PLAGE ? (O/N)");
					try{
						reponse=Global.readln();
					}
					catch(IOException e){
						reponse="N";
					}
					if((reponse.toUpperCase()).compareTo("O")==0) m_Plage_Horaire.addElement(ph);
				}
				else m_Plage_Horaire.addElement(ph);
			}
		}
	}
	
/** Saisie d'un utilisateur */
	private String[] saisieUtil(){
		String[] liste = new String[4];
		try{
			liste[0]=""+(++lastId);
			System.out.print("NOM : "); 
			liste[1]=Global.readln();
			System.out.print("PRENOM : "); 
			liste[2]=Global.readln();
			System.out.print("LOGIN : "); 
			liste[3]=Global.readln();
			return liste;
		}
		catch (IOException e){
			Global.msgErreur("AGENDA.saisieUtil : "+e.getMessage(),false);
			return liste;
		}
	}
	
/** Saisie d'une plage horaire */  /*ATTENTION  supprimer*/
//	private String[] saisiePlage(){
//
//		String[] elem ={"","","","","",""};
//		
//		try{
//			while (elem[0]==""){
//				System.out.print("Date debut : ");
//				elem[0] = new String(Global.readln());
//				if (!DATE.formatDate(elem[0])){
//					Global.msgErreur("Format invalide (JJ/MM/AAAA)",false);
//					elem[0]="";
//				}
//			}
//			while (elem[1]==""){
//				System.out.print("Heure debut : ");
//				elem[1] = new String(Global.readln());
//				if (!DATE.formatHeure(elem[1])){
//					Global.msgErreur("Format invalide (HH:MM)",false);
//					elem[1]="";
//				}
//			}
//			while (elem[2]==""){
//				System.out.print("Date fin : ");
//				elem[2] = new String(Global.readln());
//				if (!DATE.formatDate(elem[2])){
//					Global.msgErreur("Format invalide (JJ/MM/AAAA)",false);
//					elem[2]="";
//				}
//			}
//			while (elem[3]==""){
//				System.out.print("Heure fin : ");
//				elem[3] = new String(Global.readln());
//				if (!DATE.formatHeure(elem[3])){
//					Global.msgErreur("Format invalide (HH:MM)",false);
//					elem[3]="";
//				}
//			}
//			System.out.print("Objet : ");
//			elem[4] = new String(Global.readln());
//			System.out.print("Description : ");
//			elem[5] = new String(Global.readln());
//			return elem;		
//		}
//		catch (IOException e){
//			Global.msgErreur("AGENDA.saisiePlage : "+e.getMessage(),false);
//			return null;
//		}
//
//	}

/** Vrification du format des champs d'une plage horaire
/** @p plage horaire
*/
	private String[] format(String[] p){
		
		if (!DATE.formatDate(p[0])){
			Global.msgErreur("Format Date Debut invalide (JJ/MM/AAAA)",false);
			return null;
		}
		if (!DATE.formatHeure(p[1])){
			Global.msgErreur("Format Heure Debut invalide (HH:MM)",false);
			return null;
		}
		if (!DATE.formatDate(p[2])){
			Global.msgErreur("Format Date Fin invalide (JJ/MM/AAAA)",false);
			return null;
		}
		if (!DATE.formatHeure(p[3])){
			Global.msgErreur("Format Heure Fin invalide (HH:MM)",false);
			return null;
		}
		return p;		
	}

/*ATTENTION  supprimer*/
//	private Vector saisiePlageId(){
//		Vector vec=new Vector();
//		boolean end=false;
//		String reponse="";
//		System.out.println("-- PERSONNE --");
//		while(end==false){
//			System.out.print("ID : ");
//			try{reponse=Global.readln();}
//			catch(IOException e){reponse="";}
//			if (reponse.length()>0){
//				vec.addElement(reponse);
//			}
//			else end=true;
//		}	
//		return vec;
//	}
	
/*ATTENTION  supprimer*/
//	private Vector saisiePlageURL(){
//		Vector vec=new Vector();
//		boolean end=false;
//		String reponse="";
//		System.out.println("-- URL --");
//		while(end==false){
//			System.out.print("URL : ");
//			try{reponse=Global.readln();}
//			catch(IOException e){reponse="";}
//			if (reponse.length()>0){
//				vec.addElement(reponse);
//			}
//			else end=true;
//		}
//		return vec;
//	}

//Recuperation des arguments a traiter
	private Vector saisiePostal(){
		boolean end=false;
		String reponse="";
		String[] liste = new String[6];
		String view;
		boolean[] lview = new boolean[6];
		Vector vec=new Vector();
		
		try{
			System.out.println("-- ADRESSE --");
			while(end==false){
				System.out.print("NUMERO DE RUE : "); 
				liste[0]=Global.readln();
				System.out.print("View (h/s) : ");
				view=Global.readln();
				if (view.compareTo("h")==0) lview[0]=false;
				else lview[0]=true;
				
				System.out.print("NOM DE RUE : "); 
				liste[1]=Global.readln();
				System.out.print("View (h/s) : ");
				view=Global.readln();
				if (view.compareTo("h")==0) lview[1]=false;
				else lview[1]=true;
				
				System.out.print("VILLE : "); 
				liste[2]=Global.readln();
				System.out.print("View (h/s) : ");
				view=Global.readln();
				if (view.compareTo("h")==0) lview[2]=false;
				else lview[2]=true;
				
				System.out.print("CODE POSTAL : "); 
				liste[3]=Global.readln();
				System.out.print("View (h/s) : ");
				view=Global.readln();
				if (view.compareTo("h")==0) lview[3]=false;
				else lview[3]=true;
				
				System.out.print("TELEPHONE : "); 
				liste[4]=Global.readln();
				System.out.print("View (h/s) : ");
				view=Global.readln();
				if (view.compareTo("h")==0) lview[4]=false;
				else lview[4]=true;
				
				System.out.print("FAX : "); 
				liste[5]=Global.readln();
				vec.addElement(new POSTAL(liste,lview));
				System.out.print("View (h/s) : ");
				view=Global.readln();
				if (view.compareTo("h")==0) lview[5]=false;
				else lview[5]=true;
				
				System.out.print("Autre adresse ? (O/N) : ");
				reponse=Global.readln();
				if((reponse.toUpperCase()).compareTo("O")!=0) end=true;
			}
		}
		catch (IOException e){
			Global.msgErreur("AGENDA.saisiePostal : "+e.getMessage(),false);
		}
		return vec;	
	}
	
//Recuperation des arguments a traiter	
	private Vector saisieAutreEmail(){
		Vector vec=new Vector();
		E_MAIL email;
		boolean view=false;
		String rView;
		boolean end=false;
		String reponse="";

		System.out.println("-- EMAIL --");
		while(end==false){
			System.out.print("EMAIL : ");
			try{
				reponse=Global.readln();
				
				if (reponse.length()>0){
					System.out.print("View (h/s) : ");
					rView=Global.readln();
					if (rView.compareTo("h")==0) view=false;
					else view=true;
				}
			}
			catch(IOException e){reponse="";}
			if (reponse.length()>0){
				email=new E_MAIL(view,reponse);
				vec.addElement(email);
			}
			else end=true;
		}
		return vec;
	}
//Recuperation des arguments a traiter
	private Vector saisieAutrePortable(){
		Vector vec=new Vector();
		PORTABLE portable;
		boolean view=false;
		boolean end=false;
		String reponse="";
		String rView;
		
		System.out.println("-- PORTABLE --");
		while(end==false){
			System.out.print("PORTABLE : ");
			try{
				reponse=Global.readln();
				if (reponse.length()>0){
					System.out.print("View (h/s) : ");
					rView=Global.readln();
					if (rView.compareTo("h")==0) view=false;
					else view=true;
				}
			}
			catch(IOException e){reponse="";}
			if (reponse.length()>0){
				portable=new PORTABLE(view,reponse);
				vec.addElement(portable);
			}
			else end=true;
		}
		return vec;

	}

/* fonctions retournant la valeur des variables d'etat */

/** R&eacute;cup&eacute;ration du dernier identifiant g&eacute;n&eacute;r&eacute;.
 * @return Valeur du dernier identifiant g&eacute;n&eacute;r&eacute;
 */
	public static int getLastId(){
		return lastId;
	}

/** D&eacute;finition de la valeur du dernier identifiant.
 * @param Nouvelle valeur de l'identifiant.
 */	
	public void setLastId(int i){
		lastId=i;
	}

/** R&eacute;cup&eacute;ration du nom du fichier contenant la liste des administrateurs.
 * @return Le nom du fichier.
 */
	public static String fAdmin(){
		return ficA;
	}
	
/** R&eacute;cup&eacute;ration du nom du fichier contenant la liste des lecteurs.
 * @return Le nom du fichier.
 */
	public static String fLecteur(){
		return ficL;
	}
	
/** R&eacute;cup&eacute;ration du nom du fichier contenant la liste des plages horaires.
 * @return Le nom du fichier.
 */
	public static String fCalendrier(){
		return ficC;
	}
	
/** R&eacute;cup&eacute;ration du nom du r&eacute;pertoire de travail.
 * @return Le nom du r&eacute;pertoire.
 */
	public static String fRepertoire(){
		return repertoire;
	}
	
/** R&eacute;cup&eacute;ration du nom du fichier de configuration.
 * @return Le nom du fichier.
 */
	public static String fAgenda(){
		return sagenda;
	}

/** R&eacute;cup&eacute;ration du ttl.
 * @return Le ttl par d&eacute;faut.
 */
	public static long getTtl(){
		return ttl;
	}

/** Affiche la liste des administrateurs.
 * @param adm vrai si l'utilisateur est un administrateur.
 */
	public void afficheAdmin(boolean adm){
		System.out.println("ADMINISTRATEURS");
		for(int i=0;i<m_Administrateur.size();i++)((ADMINISTRATEUR)m_Administrateur.elementAt(i)).affiche(adm);
	}

/** Affiche la liste des lecteurs.
 * @param adm vrai si l'utilisateur est un administrateur.
 */
 	public void afficheLecteur(boolean adm){
		System.out.println("LECTEURS");
		for(int i=0;i<m_Lecteur.size();i++) ((LECTEUR)m_Lecteur.elementAt(i)).affiche(adm);
	}

/** Affiche la liste de tous les utilisateurs
 * @param adm vrai si l'utilisateur est un administrateur.
 */
 	public void afficheUtilisateur(boolean adm){
 		System.out.println("ADMINISTRATEURS");
		for(int i=0;i<m_Administrateur.size();i++)((ADMINISTRATEUR)m_Administrateur.elementAt(i)).affiche(adm);
		System.out.println("LECTEURS");
		for(int i=0;i<m_Lecteur.size();i++) ((LECTEUR)m_Lecteur.elementAt(i)).affiche(adm);
	}

/** Affiche la liste des plages horaires
 * @param adm vrai si l'utilisateur est un administrateur.
 */
	public void affichePlageHoraire(boolean adm){
		System.out.println("PLAGES HORAIRES");
		for(int i=0;i<m_Plage_Horaire.size();i++)((PLAGE_HORAIRE)m_Plage_Horaire.elementAt(i)).affiche(adm);
	}

/** V&eacute;rifie que le lecteur peut se connecter.
 * @param login login de connexion.
 * @param password lmot de passe.
 * @return vrai si la connexion est autoris&eacute;e.
 */
	public boolean rechercheAutorisationLecteur(String login, String password){
		boolean verif=false;
		for(int i=0;i<m_Administrateur.size();i++){
			verif=((UTILISATEUR)m_Administrateur.elementAt(i)).verifAutorisation(login,password);
			if (verif) return verif;
		}
		for(int i=0;i<m_Lecteur.size();i++){
			verif=((UTILISATEUR)m_Lecteur.elementAt(i)).verifAutorisation(login,password);
			if (verif) return verif;
		}
		return verif;
	}
	
/** V&eacute;rifie que l'administrateur peut se connecter.
 * @param login login de connexion.
 * @param password lmot de passe.
 * @return vrai si la connexion est autoris&eacute;e.
 */
	public boolean rechercheAutorisationAdmin(String login, String password){
		boolean verif=false;
		for(int i=0;i<m_Administrateur.size();i++){
			verif=((UTILISATEUR)m_Administrateur.elementAt(i)).verifAutorisation(login,password);
			if (verif) return verif;
		}
		return verif;
	}
	
/** Recherche l'administrateur li&eacute; au login.
 * @param login le login de l'utilisateur recherch&eacute;.
 * @return l'utilisateur s'il existe, null sinon.
 */
	public ADMINISTRATEUR rechercheAdmin(String login){
		boolean verif=false;
		for(int i=0;i<m_Administrateur.size();i++){
			verif=((UTILISATEUR)m_Administrateur.elementAt(i)).verifAutorisation(login);
			if (verif) return (ADMINISTRATEUR)m_Administrateur.elementAt(i);
		}
		return null;
	}
	
/** Recherche le lecteur li&eacute; au login.
 * @param login le login de l'utilisateur recherch&eacute;.
 * @return l'utilisateur s'il existe, null sinon.
 */
	public LECTEUR rechercheLecteur(String login){
		boolean verif=false;
		for(int i=0;i<m_Lecteur.size();i++){
			verif=((UTILISATEUR)m_Lecteur.elementAt(i)).verifAutorisation(login);
			if (verif) return (LECTEUR)m_Lecteur.elementAt(i);
		}
		return null;
	}
	
/** R&eacute;cup&eacute;ration de la liste des utilisateurs.
 * @return la liste des utilisateurs (administrateurs + lecteurs).
 */
	public Vector utilisateurs(){
		Vector v=new Vector();
		int i=0;
		int j=0;
		
 		boolean verif=false;
 		
	 		while((i<m_Administrateur.size())&&(j<m_Lecteur.size())){
				verif=((UTILISATEUR)m_Administrateur.elementAt(i)).plusGrand((UTILISATEUR)m_Lecteur.elementAt(j));
					if(verif){
					v.addElement((UTILISATEUR)m_Lecteur.elementAt(j));
					j++;
	 			}
	 			else {
					v.addElement((UTILISATEUR)m_Administrateur.elementAt(i));
					i++;
	 			}
	 		}
		for(int k=i;k<m_Administrateur.size();k++)v.addElement((UTILISATEUR)m_Administrateur.elementAt(k));
		for(int k=j;k<m_Lecteur.size();k++)v.addElement((UTILISATEUR)m_Lecteur.elementAt(k));
		return v;
 	}
 	
/** R&eacute;cup&eacute;ration de la liste des administrateurs.
 * @return La liste des administrateurs.
 */
 	public Vector getAdministrateurs(){
 		return m_Administrateur;
 	}
 	
/** R&eacute;cup&eacute;ration de la liste des lecteurs.
 * @return La liste des lecteurs.
 */
 	public Vector getLecteurs(){
 		return m_Lecteur;
 	}
 	
/** Supprime un administrateur.
 * @param u l'adimistrateur &agrave; supprimer.
 * @return Vrai si l'admnistrateur a &eacute;t&eacute; supprim&eacute;, faux sinon.
 */
	public boolean suppressionAdmin(UTILISATEUR u){
		modif=true;
		return Global.suppresAll(m_Administrateur,u);
	}

/** Supprime un lecteur.
 * @param u le lecteur &agrave; supprimer.
 * @return Vrai si le lecteur a &eacute;t&eacute; supprim&eacute;, faux sinon.
 */
	public boolean suppressionLecteur(UTILISATEUR u){
		modif=true;
		return Global.suppresAll(m_Lecteur,u);
	}
	
/** Supprime une adresse.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur li&eacute; &agrave; l'adresse &agrave; supprimer.
 * @param i la position de l'adresse &agrave; supprimer.
 * @return Vrai si l'adresse a &eacute;t&eacute; supprim&eacute;e, faux sinon.
 */
	public boolean suppressionAdresse(Vector v,int index, int i){
		modif=true;
		return ((UTILISATEUR)v.elementAt(index)).removeAdresse(i);
	}
	
/** Supprime une adresse email.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur li&eacute; &agrave; l'adresse email &agrave; supprimer.
 * @param i la position de l'adresse email &agrave; supprimer.
 * @return Vrai si l'adresse email a &eacute;t&eacute; supprim&eacute;e, faux sinon.
 */
	public boolean suppressionEmail(Vector v,int index, int i){
		modif=true;
		return ((UTILISATEUR)v.elementAt(index)).removeEmail(i);
	}
	
/** Supprime un num&eacute;ro de portable.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur li&eacute; au num&eacute;ro &agrave; supprimer.
 * @param i la position du num&eacute;ro &agrave; supprimer.
 * @return Vrai si le num&eacute;ro &eacute;t&eacute; supprim&eacute;, faux sinon.
 */
	public boolean suppressionPortable(Vector v,int index, int i){
		modif=true;
		return ((UTILISATEUR)v.elementAt(index)).removePortable(i);
	}
	
/** Ajoute une adresse email.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur &agrave; qui doit tre ajout&eacute; l'adresse email.
 * @param e l'adresse email &agrave; ajouter.
 */
	public void addEmail(Vector v,int index, E_MAIL e){
		modif=true;
		((UTILISATEUR)v.elementAt(index)).addEmail(e);
	}

/** Ajoute un num&eacute;ro de portable.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur &agrave; qui doit tre ajout&eacute; le num&eacute;ro de portable.
 * @param p le num&eacute;ro de portable &agrave; ajouter.
 */
	public void addPortable(Vector v,int index, PORTABLE p){
		modif=true;
		((UTILISATEUR)v.elementAt(index)).addPortable(p);
	}
	
/** Ajoute une adresse.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur &agrave; qui doit tre ajout&eacute; l'adresse.
 * @param p l'adresse &agrave; ajouter.
 */
	public void addAdresse(Vector v,int index, POSTAL p){
		modif=true;
		((UTILISATEUR)v.elementAt(index)).addAdresse(p);
	}
	
/** Modifie les caract&eacute;ristiques d'un utilisateur.
 * @param v la liste des utilisateurs.
 * @param index la position de l'utilisateur &agrave; modifier.
 * @param nom le nouveau nom.
 * @param prenom le nouveau pr&eacute;nom.
 * @param login le nouveau login.
 * @param pswd le nouveau password.
 */
	public void modifUtilisateur(Vector v, int index, String nom, String prenom, String login, String pswd){
		modif=true;
		((UTILISATEUR)v.elementAt(index)).modif(nom,prenom,login,pswd);
	}
	
/** Permet de r&eacute;cup&eacute;rer l'adresse du serveur.
 * @return l'URL du serveur.
 */
	public static String getUrl(){
		return url;
	}
	
/** Permet de d&eacute;terminer si une date est comprise dans une plage horaire.
 * @param d la date &agrave; tester.
 * @return vrai si la date est comprise dans une plage horaire, faux sinon.
 */
	public boolean occupe(DATE d){
		for(int i=0;i<m_Plage_Horaire.size();i++) if (((PLAGE_HORAIRE)m_Plage_Horaire.elementAt(i)).occupe(d,0,0,23,59)) return true;
		return false;
	}
}
