package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;
import SmartAgenda.Net.*;

/** Classe g&eacute;rant les portables et les adresses e-mail.
 */
public class AUTRE_COM {
	private Vector m_Email;
	private Vector m_Portable;

/* CONSTRUCTEURS */

/** Cr&eacute;e une nouvelle instance de la classe.
 */
	public AUTRE_COM() {
		m_Email= new Vector();
		m_Portable= new Vector();
	}
	
/** Cr&eacute;ation d'une nouvelle instance de la classe.
 * @param lEmail Vecteur de String contenant les emails
 * @param lPortable Vecteur de String contenant les portables
 */	
	public AUTRE_COM(Vector lEmail,Vector lPortable) {
		m_Email= lEmail;
		m_Portable= lPortable;
	}

/* FONCTIONS DE SAUVEGARDE */		

/** Sauvegarde de l'instance dans un fichier.
 * @param fic le fichier de sauvegarde
 * @param xml si Vrai alors le fichier de sauvegarde est au format xml, sinon au format agd
 */
	public void save(FileWriter fic,boolean xml){
		int sEmail=m_Email.size();
		int sPortable=m_Portable.size();
		try{
			if (sEmail+sPortable!=0){
				fic.write("<AUTRE>");
				for (int i=0;i<sEmail;i++){
					fic.write("<EMAIL VIEW="+Global.sVerif(Global.QUOT,xml)+((E_MAIL)m_Email.elementAt(i)).view()+Global.sVerif(Global.QUOT,xml)+">"+((E_MAIL)m_Email.elementAt(i)).email());
					if (xml) fic.write("</EMAIL>"+Global.CRLF);
				}
				for (int i=0;i<sPortable;i++){
					fic.write("<PORTABLE VIEW="+Global.sVerif(Global.QUOT,xml)+((PORTABLE)m_Portable.elementAt(i)).view()+Global.sVerif(Global.QUOT,xml)+">"+((PORTABLE)m_Portable.elementAt(i)).portable());
					if (xml) fic.write("</PORTABLE>"+Global.CRLF);
				}
				if (xml) fic.write("</AUTRE>"+Global.CRLF);
			}
		}
		catch (IOException e){
			Global.msgErreur("AUTRE_COM.save : "+e.getMessage(),false);
		}
	}

/* AJOUT DE DONNEES */

/** Ajout d'e-mail et de portable.
 * @param liste Vecteur contenant la liste des e-mails et des portables.
 */
	public void add(Vector liste){
		E_MAIL e;
		PORTABLE p;
		Boolean tmp;
		
		for(int i=0;i<liste.size()-2;i++){
			if(((String)liste.elementAt(i)).compareTo("EMAIL VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				e=new E_MAIL(tmp.booleanValue(),(String)liste.elementAt(++i));
				m_Email.addElement(e);
			}
			else if(((String)liste.elementAt(i)).compareTo("PORTABLE VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				p=new PORTABLE(tmp.booleanValue(),(String)liste.elementAt(++i));
				m_Portable.addElement(p);
			}
		}
	}
	
/* AFFICHAGE A L'ECRAN DE L'UTILISATEUR */
/** Affiche &agrave; l'&eacute;cran le contenu de l'objet.
 * @param adm vrai si l'utilisateur est un administrateur.
 */
	public void affiche(boolean adm){
		E_MAIL e;
		PORTABLE p;
		for(int i=0;i<m_Email.size();i++){
			e=(E_MAIL)m_Email.elementAt(i);
			if(e.view()||adm) System.out.println("Email : "+e.email());
		}
		for(int i=0;i<m_Portable.size();i++){
			p=(PORTABLE)m_Portable.elementAt(i);
			if(p.view()||adm) System.out.println("Portable : "+p.portable());
		}
	}
	
/* AJOUT D'UN EMAIL */

/** Ajoute un email dans la liste
 * @param email l'e-mail &agrave; ins&eacute;rer.
 */
	public void addEmail (E_MAIL email){
		m_Email.addElement(email);
	}

/* AJOUT D'UN PORTABLE */
	
/** Ajoute un num&eacute;ro de portable dans la liste
 * @param portable le num&eacute;ro &agrave; ins&eacute;rer.
 */
	public void addPortable (PORTABLE portable){
		m_Portable.addElement(portable);
	}

/* Retourne false si m_Email ou m_Portable contient au moins un element. */
/** Test si la classe ne contient ni emails, ni portables.
 * @return Vrai si la classe est vide.
 */
	public boolean vide(){
		return (m_Email.size()==0 && m_Portable.size()==0);
	}
	
/** Permet de r&eacute;cup&eacute;rer la liste des emails.
 * @return la liste des e-mails.
 */
	public Vector getEmails(){
		return m_Email;
	}
	
/** Permet de r&eacute;cup&eacute;rer la liste des portables.
 * @return la liste des portables.
 */
	public Vector getPortables(){
		return m_Portable;
	}
	
/** Permet de supprimer un email de la liste.
 * @param i index de l'email &agrave; supprimer.
 * @return vrai si la suppression a &eacute;t&eacute; r&eacute;alis&eacute;e.
 */
	public boolean removeEmail(int i){
		if (i>=0 && i<m_Email.size()) m_Email.remove(i);
		return true;
	}
	
/** Permet de supprimer un num&eacute;ro de portable de la liste.
 * @param i index du num&eacute;ro de portable &agrave; supprimer.
 * @return vrai si la suppression a &eacute;t&eacute; r&eacute;alis&eacute;e.
 */
	public boolean removePortable(int i){
		if (i>=0 && i<m_Portable.size()) m_Portable.remove(i);
		return true;
	}

/** Permet de sauvegarder le contenu de l'objet sur un serveur.
 * @param first d&eacute;termine s'il s'agit du premier paquet envoy&eacute; au serveur.
 * @param l  d&eacute;termine s'il s'agit du dernier paquet envoy&eacute; au serveur.
 * @param url adresse du serveur. 
 * @return vrai si le transfert s'est bien effectu&eacute;, faux sinon.
 */
	public boolean saveDistant(boolean first,boolean l,String url){
		int sEmail=m_Email.size();
		int sPortable=m_Portable.size();
		boolean last;
		boolean resultat=true;
		String val;
		String msg;
		
		if (sEmail+sPortable!=0){
			for (int i=0;i<sEmail;i++){
				last=(i==(sEmail-1) && sPortable==0);
				if (last) val="close";
				else val="app";
				msg="val="+DataURLAccess.urlEncode(val)+"&email="+DataURLAccess.urlEncode(((E_MAIL)m_Email.elementAt(i)).email())+"&ve="+DataURLAccess.urlEncode(((E_MAIL)m_Email.elementAt(i)).view());
				resultat&= DataURLAccess.writeData(url,msg);
			}
			for (int i=0;i<sPortable;i++){
				last=(i==(sPortable-1));
				if (last) val="close";
				else val="app";
				msg="val="+DataURLAccess.urlEncode(val)+"&portable="+DataURLAccess.urlEncode(((PORTABLE)m_Portable.elementAt(i)).portable())+"&vp="+DataURLAccess.urlEncode(((PORTABLE)m_Portable.elementAt(i)).view());
				resultat&= DataURLAccess.writeData(url,msg);
			}
		}
		return resultat;
	}
}
