package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;
import SmartAgenda.Net.*;

/** Classe g&eacute;rant les adresses postales, &eacute;l&egrave;ctroniques et les num&eacute;ros de portables. */
public class FICHE {
	private AUTRE_COM m_Autre_Com;
	private Vector m_Postal;
	
/** Cr&eacute;ation d'une nouvelle instance de la classe. */
	public FICHE() {
		m_Postal= new Vector();
		m_Autre_Com = new AUTRE_COM();
	}
	
/** Cr&eacute;ation d'une nouvelle instance de la classe. 
 * @param s tableau contenant la liste des &eacute;l&eacute;ments &agrave; int&eacute;grer.
 * @param taille taille du tableau.
 */
	public FICHE(String[] s,int taille){
		Vector postal=new Vector();
		Vector autre=new Vector();
		
		m_Postal= new Vector();
		m_Autre_Com = new AUTRE_COM();
		
		for(int i=0;i<taille;i++){
			if (s[i].compareTo("POSTAL")==0){
				i++;
				for(;(i<taille)&&(s[i].compareTo("POSTAL")!=0)&&(s[i].compareTo("AUTRE")!=0);i++){
					postal.addElement(s[i]);
				}
				i--;
				m_Postal.addElement(new POSTAL(postal));
				postal=new Vector();
			}
			else if (s[i].compareTo("AUTRE")==0){
				i++;
				for(;(i<taille)&&(s[i].compareTo("POSTAL")!=0)&&(s[i].compareTo("AUTRE")!=0);i++){
					autre.addElement(s[i]);
				}
				m_Autre_Com.add(autre);
				autre=new Vector();
				i--;
			}
		}
	}
	
/** Cr&eacute;ation d'une nouvelle instance de la classe. 
 * @param lPostal liste des adresses postales.
 * @param lEmail liste des adresses e-mails.
 * @param lPortable liste des num&eacute;ros de portables.
 */
	public FICHE(Vector lPostal,Vector lEmail, Vector lPortable) {
		
		m_Postal = lPostal;
		m_Autre_Com = new AUTRE_COM(lEmail,lPortable);
	}
	
	public void save(FileWriter fic,boolean xml){
		try{
			if (m_Postal.size()>0 || m_Autre_Com.vide()!=true){
				fic.write("<ADRESSE>");
				for (int i=0;i<m_Postal.size();i++){
					((POSTAL)m_Postal.elementAt(i)).save(fic,xml);
				}
				m_Autre_Com.save(fic,xml);
				if(xml) fic.write("</ADRESSE>"+Global.CRLF);
			}
		}
		catch (IOException e)
		{
			Global.msgErreur("FICHE.insert : "+e.getMessage(),false);
		}
	}

/** R&eacute;cup&eacute;ration des adresses postales.
 * @return la liste des adresses postales.
 */
	public Vector getPostal(){
		return m_Postal;
	}
	
/** R&eacute;cup&eacute;ration des e-mails et des portables.
 * @return la liste des e-mails et des portables.
 */
	public AUTRE_COM getAutreCom(){
		return m_Autre_Com;
	}

/** Affichage des adresses.
 * @param adm vrai si la m&eacute;thode est appel&eacute; par un administrateur, faux sinon.
 */

	public void affiche(boolean adm){
		System.out.println("-- ADRESSE --");
		for(int i =0;i<m_Postal.size();i++)((POSTAL)m_Postal.elementAt(i)).affiche(adm);
		m_Autre_Com.affiche(adm);
	}

/* AJOUT D'UNE ADRESSE */

/** Ajout d'une adresse postale dans la liste.
 * @param postal l'adresse &agrave; ajouter.
 */
	public void addAdresse (POSTAL postal){
		m_Postal.addElement(postal);
	}

/* AJOUT D'UN EMAIL */

/** Ajout d'une adresse e-mail dans la liste.
 * @param email l'adresse e-mail &agrave; ajouter.
 */
	public void addEmail (E_MAIL email){
		m_Autre_Com.addEmail(email);
	}

/* AJOUT D'UN PORTABLE */
	
/** Ajout d'un num&eacute;ro de portable dans la liste.
 * @param portable le num&eacute;ro de portable &agrave; ajouter.
 */
	public void addPortable (PORTABLE portable){
		m_Autre_Com.addPortable(portable);
	}
	
/** Supprime une adresse postale de la liste.
 * @param i l'index de l'adresse &agrave; supprimer.
 * @return vrai.
 */
	public boolean removePostal(int i){
		if (i>=0 && i<m_Postal.size()) m_Postal.remove(i);
		return true;
	}
	
/** Supprime une adresse e-mail de la liste.
 * @param i l'index de l'adresse e-mail &agrave; supprimer.
 * @return vrai.
 */
	public boolean removeEmail(int i){
		return m_Autre_Com.removeEmail(i);
	}
	
/** Supprime un num&eacute;ro de portable de la liste.
 * @param i l'index du num&eacute;ro &agrave; supprimer.
 * @return vrai.
 */
	public boolean removePortable(int i){
		return m_Autre_Com.removePortable(i);
	}

/** Test que l'instance de la classe ne contient ni adresse postale, ni e-mail, ni portable.
 * @return Vrai si la classe est vide.
 */
	public boolean vide(){
		return (m_Postal.size()==0)&&m_Autre_Com.vide();
	}
	
/** Sauvegarde de la base de donn&eacute;es sur un serveur.
 * @param first variable d&eacute;terminant s'il s'agit du premier paquet envoy&eacute; au serveur ou pas.
 * @param l variable d&eacute;terminant s'il s'agit du dernier paquet envoy&eacute; au serveur ou pas.
 * @param url adresse du serveur. 
 * @return vrai si le transfert s'est bien effectu&eacute;, faux sinon.
 */
	public boolean saveDistant(boolean first,boolean l,String url){
		boolean resultat=true;
		boolean last=false;
	
		last=l && m_Autre_Com.vide();
		
		if (m_Postal.size()>0 || !m_Autre_Com.vide()){
			for (int i=0;i<m_Postal.size();i++){
				resultat&=((POSTAL)m_Postal.elementAt(i)).saveDistant(first,last&&(i==m_Postal.size()-1),url);
				if (!resultat) break;
			}
			resultat&=m_Autre_Com.saveDistant(first,l,url);
		}
		return resultat;
	}
}
