package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;
import SmartAgenda.Net.*;

/** Classe permettant la gestion des plages horaires.*/
public class PLAGE_HORAIRE {
	private String m_Date_Debut;
	private String m_Heure_Debut;
	private String m_Date_Fin;
	private String m_Heure_Fin;
	private String m_Objet;
	private String m_Description;
	private Vector m_Lecteur; /* OID des objets UTILISATEUR */
	private Vector m_URL; /* String */

/** Cr&eacute;ation de l'instance.
 */
	public PLAGE_HORAIRE(){
		m_Lecteur = new Vector();
		m_URL = new Vector();
	}
	
/** Cr&eacute;ation de l'instance.
 * @param s chane de caract&egrave;re contenant les donn&eacute;es de la plage horaire.
 * @param lLecteur liste des lecteurs de l'agenda.
 * @param lAdmin liste des administrateurs de l'agenda.
 */
	public PLAGE_HORAIRE(String s, Vector lLecteur, Vector lAdmin){
		m_Lecteur = new Vector();
		m_URL = new Vector();
		UTILISATEUR utilisateur;
		String delim = "<>";
		String[] buf;
		String[] plage;
		int sPlage;
		boolean personne=false;
		StringTokenizer st = new StringTokenizer(s,delim);
		int limite = st.countTokens();
		
		buf=new String[limite];
		for(int i=0;i<(limite);i++)buf[i]=st.nextToken();
		if (buf[0].compareTo("PH")==0){
			for(int i=1;i<(limite);i++){
				if (buf[i].compareTo("DD")==0){
					m_Date_Debut=buf[i+1];
					i++;
				}
				else if (buf[i].compareTo("HD")==0){
					m_Heure_Debut=buf[i+1];
					i++;
				}
				else if (buf[i].compareTo("DF")==0){
					m_Date_Fin=buf[i+1];
					i++;
				}
				else if (buf[i].compareTo("HF")==0){
					m_Heure_Fin=buf[i+1];
					i++;
				}
				else if (buf[i].compareTo("OBJET")==0){
					m_Objet=buf[i+1];
					i++;
				}
				else if (buf[i].compareTo("DESC")==0){
					m_Description=buf[i+1];
					i++;
				}
				else if (buf[i].compareTo("PERSONNE")==0){
					personne=true;
				}
				else if (buf[i].compareTo("ID")==0){
					if (personne==false) Global.msgErreur("PLAGE_HORAIRE.constructeur : Structure du fichier non respectee",false);
					utilisateur=UTILISATEUR.rechercheUtilisateur(lAdmin,buf[i+1]);
					if (utilisateur!=null){
						m_Lecteur.addElement(utilisateur);
				 	}
					else {
						utilisateur=UTILISATEUR.rechercheUtilisateur(lLecteur,buf[i+1]);
						if (utilisateur!=null) m_Lecteur.addElement(utilisateur);
						else Global.msgErreur("ID inconnu",false);
					}
					i++;
				}
				else if (buf[i].compareTo("URL")==0){
					m_URL.addElement(buf[i+1]);
				}
			}
		}
		else Global.msgErreur("PLAGE_HORAIRE.constructeur : fichier incorrect (not an calendrier file)",false);
	}

/** Cr&eacute;ation de l'instance ( partir d'un fichier XML).
 * @param s chane de caract&egrave;re contenant les donn&eacute;es de la plage horaire.
 * @param lLecteur liste des lecteurs de l'agenda.
 * @param lAdmin liste des administrateurs de l'agenda.
 * @param b vaut "true" pour XML ("false"  ajouter pour AGD et donc remplacer le constructeur ci-dessus)
 */
//	public PLAGE_HORAIRE(String s, Vector lLecteur, Vector lAdmin, boolean b){    /*ATTENTION ne fonctionne pas*/
//		m_Lecteur = new Vector();
//		m_URL = new Vector();
//		UTILISATEUR utilisateur;
//		String delim = "<>";
//		String[] buf;
//		String[] plage;
//		int sPlage;
//		boolean personne=false;
//		StringTokenizer st = new StringTokenizer(s,delim);
//		int limite = st.countTokens();
//		
//		buf=new String[limite];
//		for(int i=0;i<(limite);i++)buf[i]=st.nextToken();
//		if (buf[0].compareTo("PH")==0){
//			for(int i=1;i<(limite);i++){
//				if (buf[i].compareTo("DD")==0){
//					m_Date_Debut=buf[i+1];
//					i++;i++;
//				}
//				else if (buf[i].compareTo("HD")==0){
//					m_Heure_Debut=buf[i+1];
//					i++;i++;
//				}
//				else if (buf[i].compareTo("DF")==0){
//					m_Date_Fin=buf[i+1];
//					i++;i++;
//				}
//				else if (buf[i].compareTo("HF")==0){
//					m_Heure_Fin=buf[i+1];
//					i++;i++;
//				}
//				else if (buf[i].compareTo("OBJET")==0){
//					m_Objet=buf[i+1];
//					i++;i++;
//				}
//				else if (buf[i].compareTo("DESC")==0){
//					m_Description=buf[i+1];
//					i++;i++;
//				}
//				else if (buf[i].compareTo("PERSONNE")==0){
//					personne=true;
//				}
//				else if (buf[i].compareTo("ID")==0){
//					if (personne==false) Global.msgErreur("PLAGE_HORAIRE.constructeur : Structure du fichier non respectee",false);
//					utilisateur=UTILISATEUR.rechercheUtilisateur(lAdmin,buf[i+1]);
//					if (utilisateur!=null){
//						m_Lecteur.addElement(utilisateur);
//				 	}
//					else {
//						utilisateur=UTILISATEUR.rechercheUtilisateur(lLecteur,buf[i+1]);
//						if (utilisateur!=null) m_Lecteur.addElement(utilisateur);
//						else Global.msgErreur("ID inconnu",false);
//					}
//					i++;
//				}
//				else if (buf[i].compareTo("URL")==0){
//					m_URL.addElement(buf[i+1]);
//				}
//			}
//		}
//		else Global.msgErreur("PLAGE_HORAIRE.constructeur : fichier incorrect (not an calendrier file)",false);
//	}

/** Cr&eacute;ation de l'instance.
 * @param lArgs tableau contenant les donn&eacute;es de la plage horaire : <BR>[0] : date debut, [1] : heure debut, [2] : date fin, [3] : heure fin, [4] : objet, [5] : description.
 * @param lLecteur liste des participants.
 * @param lURL liste des URLs.
 */
	public PLAGE_HORAIRE(String[] lArgs,Vector lLecteur, Vector lURL){
	/* Ordre des elements [i] de lArgs :
  	[0] : date debut, [1] : heure debut, [2] : date fin, [3] : heure fin, [4] : objet, [5] : description */ 
		m_Date_Debut = lArgs[0];
		m_Heure_Debut = lArgs[1];
		m_Date_Fin = lArgs[2];
		m_Heure_Fin = lArgs[3];
		m_Objet = lArgs[4];
		m_Description = lArgs[5];
		m_Lecteur = lLecteur;
		m_URL = lURL;
	}
	
/** Permet la sauvegarde de la plage horaire.
 * @param fic fichier de sauvegarde.
 * @param xml si vrai, le fichier de sauvegarde doit respecter la DTD.
 */
	public void save(FileWriter fic,boolean xml){
		try{
			fic.write(Global.CRLF+"<PH>");
			fic.write("<DD>"+Global.nonVide(m_Date_Debut," "));
			if (xml)fic.write("</DD>"+Global.CRLF);
			fic.write("<HD>"+Global.nonVide(m_Heure_Debut," "));
			if (xml)fic.write("</HD>"+Global.CRLF);
			fic.write("<DF>"+Global.nonVide(m_Date_Fin," "));
			if (xml)fic.write("</DF>"+Global.CRLF);
			fic.write("<HF>"+Global.nonVide(m_Heure_Fin," "));
			if (xml)fic.write("</HF>"+Global.CRLF);
			fic.write("<OBJET>"+Global.nonVide(m_Objet," "));
			if (xml)fic.write("</OBJET>"+Global.CRLF);
			fic.write("<DESC>"+Global.nonVide(m_Description," "));
			if (xml)fic.write("</DESC>"+Global.CRLF);
			if (m_Lecteur.size()>0){
				fic.write("<PERSONNE>");
				for(int i=0;i<m_Lecteur.size();i++){
					fic.write("<ID>"+((UTILISATEUR)m_Lecteur.elementAt(i)).identifiant());
					if (xml)fic.write("</ID>"+Global.CRLF);
				}
				if (xml)fic.write("</PERSONNE>"+Global.CRLF);
			}
			for(int i=0;i<m_URL.size();i++){
				fic.write("<URL>"+(String)m_URL.elementAt(i));
				if (xml)fic.write("</URL>"+Global.CRLF);
			}
			if (xml)fic.write("</PH>"+Global.CRLF);
		}
		catch (IOException e)
		{
			Global.msgErreur("PLAGE_HORAIRE.insert : "+e.getMessage(),false);
		}
	}
	
/** Affichage texte de la plage horaire.
 * @param adm si vrai, l'utilisateur est un administrateur.
 */
	public void affiche(boolean adm){
		System.out.println("["+m_Date_Debut+";"+m_Heure_Debut+"] -> ["+m_Date_Fin+";"+m_Heure_Fin+"] : "+m_Objet);
 		System.out.println(m_Description);
		for(int i=0;i<m_Lecteur.size();i++) ((UTILISATEUR)m_Lecteur.elementAt(i)).afficheLight();
		for(int i=0;i<m_URL.size();i++)System.out.println("URL : "+(String)m_URL.elementAt(i));
	}
	
/** Verifie que la plage horaire est valide. */
	public boolean gestionCoherence(){
		DATE dd;
		DATE df;
		try{
			dd = new DATE(m_Date_Debut,m_Heure_Debut);
			df = new DATE(m_Date_Fin,m_Heure_Fin);
			return dd.inf(df);
		}
		catch (DATEException d)
		{
			System.out.println("PLAGE_HORAITRE.gestionCoherence : "+d.getMessage());
			return false;
		}
	}

/** verifie que la plage horaire n'est pas en conflit avec les autres.
 * @param liste liste des plages horaires d&eacute;ja existantes.
 */
	public boolean gestionConflit(Vector liste) {
		DATE dd1;
		DATE df1;
		DATE dd2;
		DATE df2;
		
		boolean conflit=false;
	
		for (int i=0;(i<liste.size())&&conflit==false;i++){
			try{
				dd1 = new DATE(m_Date_Debut,m_Heure_Debut);
				df1 = new DATE(m_Date_Fin,m_Heure_Fin);
				dd2 = new DATE(((PLAGE_HORAIRE)liste.elementAt(i)).dateDebut(),((PLAGE_HORAIRE)liste.elementAt(i)).heureDebut());
				df2 = new DATE(((PLAGE_HORAIRE)liste.elementAt(i)).dateFin(),((PLAGE_HORAIRE)liste.elementAt(i)).heureFin());
				if (df1.inf(dd2)) conflit=false;
				else if (dd1.sup(df2)) conflit=false;
				else conflit=true;
			}
			catch (DATEException d)
			{
				System.out.println("PLAGE_HORAITRE.gestionConflit : "+d.getMessage());
				return false;
			}
		}
		return conflit;
	}

/** Permet de r&eacute;cup&eacute;rer l'heure de d&eacute;but de la plage horaire.
 * @return l'heure de d&eacute;but de la plage horaire.
 */
	public String heureDebut(){
		return m_Heure_Debut;
	}
	
/** Permet de r&eacute;cup&eacute;rer l'heure de fin de la plage horaire.
 * @return l'heure de fin de la plage horaire.
 */
	public String heureFin(){
		return m_Heure_Fin;
	}
	
/** Permet de r&eacute;cup&eacute;rer la date de fin de la plage horaire.
 * @return la date de fin de la plage horaire.
 */
	public String dateFin(){
		return m_Date_Fin;
	}
	
/** Permet de r&eacute;cup&eacute;rer la date de d&eacute;but de la plage horaire.
 * @return la date de d&eacute;but de la plage horaire.
 */
	public String dateDebut(){
		return m_Date_Debut;
	}

/** Permet de r&eacute;cup&eacute;rer l'objet de la plage horaire.
 * @return l'objet de la plage horaire.
 */
	public String getObjet(){
		return m_Objet;
	}

/** D&eacute;termine si un instant donn&eacute; (date) est compris dans une plage horaire existante ou pas.
 * @param d l'instant &agrave; tester.
 * @return vrai si au moins une plage horaire comprend l'instant, faux sinon.
 */
//	public boolean occupe(DATE d){
//		try{
//			if ((d.sup(new DATE(m_Date_Debut,"00:00"))||d.egal(new DATE(m_Date_Debut,"00:00"))) && (d.inf(new DATE(m_Date_Fin,"23:59"))||d.egal(new DATE(m_Date_Fin,"23:59")))) return true;
//			else return false;
//		}
//		catch (DATEException e){
//			return false;
//		}
//	}

/** D&eacute;termine si un instant donn&eacute; (date+heure) est compris dans une plage horaire existante ou pas.
 * @param d l'instant &agrave; tester.
 * @param hd heures de dbut de l'instant &agrave; tester.
 * @param md minutes de dbut de l'instant &agrave; tester.
 * @param hf heures de fin de l'instant &agrave; tester.
 * @param mf minutes de fin de l'instant &agrave; tester.
 * @return vrai si au moins une plage horaire comprend l'instant, faux sinon.
 */
	public boolean occupe(DATE d,int hd,int md,int hf,int mf){
		try{
			if (((d.setHoraire(hf,mf)).sup(new DATE(m_Date_Debut,m_Heure_Debut))) && ((d.setHoraire(hd,md)).inf(new DATE(m_Date_Fin,m_Heure_Fin)))) return true;
			else return false;
		}
		catch (DATEException e){
			return false;
		}
	}

/** Permet de sauvegarder sur un serveur la plage horaire.
 * @param first d&eacute;termine s'il s'agit du premier paquet envoy&eacute; au serveur.
 * @param last d&eacute;termine s'il s'agit du dernier paquet envoy&eacute; au serveur.
 * @param url url du serveur.
 * @return vrai si l'op&eacute;ration s'est correctement pass&eacute;e, faux sinon.
 */
	public boolean saveDistant(boolean first,boolean last,String url){
		String val;
		String msg;
		boolean resultat=false;
		int sURL=m_URL.size();
		int sLecteur=m_Lecteur.size();

		if ((sLecteur==0)&&(sURL==0) && (m_Objet.length()==0) && (m_Description.length()==0)){
			if (first && !last) val="new";
			else if(first && last) val="only";
			else if(!first && last) val="close";
			else val="app";
			
			msg="val="+DataURLAccess.urlEncode(val)+"&dd="+DataURLAccess.urlEncode(m_Date_Debut)+"&hd="+DataURLAccess.urlEncode(m_Heure_Debut)+"&df="+DataURLAccess.urlEncode(m_Date_Fin)+"&hf="+DataURLAccess.urlEncode(m_Heure_Fin);
			resultat= DataURLAccess.writeData(url,msg);
		}
		else {
			if (first) val="new";
			else val="app";
			msg="val="+DataURLAccess.urlEncode(val)+"&dd="+DataURLAccess.urlEncode(m_Date_Debut)+"&hd="+DataURLAccess.urlEncode(m_Heure_Debut)+"&df="+DataURLAccess.urlEncode(m_Date_Fin)+"&hf="+DataURLAccess.urlEncode(m_Heure_Fin);
			resultat= DataURLAccess.writeData(url,msg);
		
			if (m_Objet.length()>0){
				if(last && m_Description.length()==0 && m_Lecteur.size()==0 && m_URL.size()==0) val="close";
				else val="app";
				msg="val="+DataURLAccess.urlEncode(val)+"&objet="+DataURLAccess.urlEncode(m_Objet);
				resultat&= DataURLAccess.writeData(url,msg);
			}
			if (m_Description.length()>0){
				if(last && m_Lecteur.size()==0 && m_URL.size()==0) val="close";
				else val="app";
				
				msg="val="+DataURLAccess.urlEncode(val)+"&desc="+DataURLAccess.urlEncode(m_Description);
				resultat&= DataURLAccess.writeData(url,msg);
			}
			
			for(int i=0;i<sLecteur;i++){
				if(last && (i==(sLecteur-1)) && (m_URL.size()==0)) val="close";
				else val="app";
				msg="val="+DataURLAccess.urlEncode(val)+"&first="+(i==0)+"&id="+DataURLAccess.urlEncode(((UTILISATEUR)m_Lecteur.elementAt(i)).identifiant());
				resultat&= DataURLAccess.writeData(url,msg);
			}

			for(int i=0;i<sURL;i++){
				if(last && (i==(sURL-1))) val="close";
				else val="app";
				
				msg="val="+DataURLAccess.urlEncode(val)+"&url="+DataURLAccess.urlEncode((String)m_URL.elementAt(i));
				resultat&= DataURLAccess.writeData(url,msg);
			}
		}
		return resultat;
	}
}
