package SmartAgenda.Moteur;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;

import Outils.*;
import SmartAgenda.Net.*;

/** Classe permettant la gestion des adresses postales.*/
public class POSTAL {
	private String m_Num_Rue="";
	private String m_Rue="";
	private String m_Ville="";
	private String m_Code_Postal="";
	private String m_Telephone="";
	private String m_Fax="";

// v pour view	
	private boolean v_Num_Rue=false;
	private boolean v_Rue=false;
	private boolean v_Ville=false;
	private boolean v_Code_Postal=false;
	private boolean v_Telephone=false;
	private boolean v_Fax=false;
	
	public POSTAL() {}
	
	
/** Constructeur utilis&eacute; lors du chargement du fichier agd */
	public POSTAL(Vector liste) {
		Boolean tmp;
		for(int i=0;i<liste.size()-1;i++){
			if(((String)liste.elementAt(i)).compareTo("NUM VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				v_Num_Rue=tmp.booleanValue();
				m_Num_Rue=(String)liste.elementAt(++i);
			}
			else if(((String)liste.elementAt(i)).compareTo("RUE VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				v_Rue=tmp.booleanValue();
				m_Rue=(String)liste.elementAt(++i);
			}
			else if(((String)liste.elementAt(i)).compareTo("VILLE VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				v_Ville=tmp.booleanValue();
				m_Ville=(String)liste.elementAt(++i);
			}
			else if(((String)liste.elementAt(i)).compareTo("CODE VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				v_Code_Postal=tmp.booleanValue();
				m_Code_Postal=(String)liste.elementAt(++i);
			}
			else if(((String)liste.elementAt(i)).compareTo("TEL VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				v_Telephone=tmp.booleanValue();
				m_Telephone=(String)liste.elementAt(++i);
			}
			else if(((String)liste.elementAt(i)).compareTo("FAX VIEW")==0){
				tmp=new Boolean((String)liste.elementAt(++i));
				v_Fax=tmp.booleanValue();
				m_Fax="";
				m_Fax=(String)liste.elementAt(++i);
			}
		}	
	}
	
/** Constructeur utilis&eacute; lors de la saisie */	
	public POSTAL(String[] p, boolean[] v) {
/* Ordre des elements [i] en fonction des champs de l'interface
   [0] : Num_Rue, [1] : Rue, [2] : Ville, [3] : Code_Postal, [4] : Telephone, [5] : Fax */
		m_Num_Rue= p[0];
		m_Rue= p[1];
		m_Ville= p[2];
		m_Code_Postal= p[3];
		m_Telephone= p[4];
		m_Fax= p[5];
		v_Num_Rue= v[0];
		v_Rue= v[1];
		v_Ville= v[2];
		v_Code_Postal= v[3];
		v_Telephone= v[4];
		v_Fax= v[5];	
	}
	
/** Permet de sauvegarder l'adresse.
 * @param fic fichier de sauvegarde.
 * @param xml si vrai alors suivre la DTD.
 */
	public void save(FileWriter fic,boolean xml){
		try{
			fic.write("<POSTAL>");
			if(m_Num_Rue.length()>0){
				fic.write("<NUM VIEW="+Global.sVerif(Global.QUOT,xml)+v_Num_Rue+Global.sVerif(Global.QUOT,xml)+">"+m_Num_Rue);
				if (xml)fic.write("</NUM>"+Global.CRLF);
			}
			if(m_Rue.length()>0){
				fic.write("<RUE VIEW="+Global.sVerif(Global.QUOT,xml)+v_Rue+Global.sVerif(Global.QUOT,xml)+">"+m_Rue+"");
				if (xml)fic.write("</RUE>"+Global.CRLF);
			}
			if(m_Ville.length()>0){
				fic.write("<VILLE VIEW="+Global.sVerif(Global.QUOT,xml)+v_Ville+Global.sVerif(Global.QUOT,xml)+">"+m_Ville);
				if (xml)fic.write("</VILLE>"+Global.CRLF);
			}
			if(m_Code_Postal.length()>0){
				fic.write("<CODE VIEW="+Global.sVerif(Global.QUOT,xml)+v_Code_Postal+Global.sVerif(Global.QUOT,xml)+">"+m_Code_Postal);
				if (xml)fic.write("</CODE>"+Global.CRLF);
			}
			if(m_Telephone.length()>0){
				fic.write("<TEL VIEW="+Global.sVerif(Global.QUOT,xml)+v_Telephone+Global.sVerif(Global.QUOT,xml)+">"+m_Telephone);
				if (xml)fic.write("</TEL>"+Global.CRLF);
			}
			if(m_Fax.length()>0){
				fic.write("<FAX VIEW="+Global.sVerif(Global.QUOT,xml)+v_Fax+Global.sVerif(Global.QUOT,xml)+">"+m_Fax);
				if (xml)fic.write("</FAX>"+Global.CRLF);
			}
			if (xml)fic.write("</POSTAL>"+Global.CRLF);
		}
		catch (IOException e)
		{
			Global.msgErreur("POSTAL.save : "+e.getMessage(),false);
		}
	}

/** Affichage texte de l'adresse.
 * @param adm permet de d&eacute;terminer si l'utilisateur est un administrateur ou pas.
 */
	public void affiche(boolean adm){
		if ((v_Num_Rue||adm)&& m_Num_Rue.length()>0) System.out.print(m_Num_Rue+" ");
		if ((v_Rue||adm)&& m_Rue.length()>0) System.out.print(m_Rue+" ");
		if ((v_Code_Postal||adm)&& m_Code_Postal.length()>0) System.out.print(m_Code_Postal+" ");
		if ((v_Ville||adm)&& m_Ville.length()>0) System.out.println(m_Ville);
		if ((v_Telephone||adm)&& m_Telephone.length()>0) System.out.println("Tel : "+m_Telephone);
		if ((v_Fax||adm)&& m_Fax.length()>0) System.out.println("Fax : "+m_Fax);
	}
	
/** Permet de r&eacute;cup&eacute;rer le num&eacute;ro de rue.
 * @return le num&eacute;ro de rue.
 */
	public String getNumRue(){
		return m_Num_Rue;
	}
	
/** Permet de r&eacute;cup&eacute;rer la rue.
 * @return la rue.
 */
	public String getRue(){
		return m_Rue;
	}
	
/** Permet de r&eacute;cup&eacute;rer le code postal.
 * @return le code postal.
 */
	public String getCodePostal(){
		return m_Code_Postal;
	}

/** Permet de r&eacute;cup&eacute;rer le nom de la ville.
 * @return le nom de la ville.
 */	
	public String getVille(){
		return m_Ville;
	}
	
/** Permet de r&eacute;cup&eacute;rer le num&eacute;ro de t&eacute;l&eacute;phone.
 * @return le nom de le num&eacute;ro de t&eacute;l&eacute;phone.
 */	
	public String getTelephone(){
		return m_Telephone;
	}
	
/** Permet de r&eacute;cup&eacute;rer le num&eacute;ro de fax.
 * @return le nom de le num&eacute;ro de fax.
 */	
	public String getFax(){
		return m_Fax;
	}
	
/** Permet de r&eacute;cup&eacute;rer la visibilit&eacute; du num&eacute;ro de rue.
 * @return le nom de la visibilit&eacute; du num&eacute;ro de rue.
 */	
	public boolean getViewNumRue(){
		return v_Num_Rue;
	}
	
/** Permet de r&eacute;cup&eacute;rer la visibilit&eacute; du nom de la rue.
 * @return le nom de la visibilit&eacute; du nom de la rue.
 */	
	public boolean getViewRue(){
		return v_Rue;
	}
	
/** Permet de r&eacute;cup&eacute;rer la visibilit&eacute; du code postal.
 * @return le nom de la visibilit&eacute; du code postal.
 */	
	public boolean getViewCodePostal(){
		return v_Code_Postal;
	}

/** Permet de r&eacute;cup&eacute;rer la visibilit&eacute; de la ville.
 * @return le nom de la visibilit&eacute; de la ville.
 */	
	public boolean getViewVille(){
		return v_Ville;
	}
	
/** Permet de r&eacute;cup&eacute;rer la visibilit&eacute; du num&eacute;ro de t&eacute;l&eacute;phone.
 * @return le nom de la visibilit&eacute; du num&eacute;ro de t&eacute;l&eacute;phone.
 */	
	public boolean getViewTelephone(){
		return v_Telephone;
	}
	
/** Permet de r&eacute;cup&eacute;rer la visibilit&eacute; du num&eacute;ro de fax.
 * @return le nom de la visibilit&eacute; du num&eacute;ro de fax.
 */	
	public boolean getViewFax(){
		return v_Fax;
	}
	
/** Permet de sauvegarder la base de donn&eacute;es sur un serveur.
 * @param first variable d&eacute;terminant s'il s'agit du premier paquet envoy&eacute; au serveur ou pas.
 * @param last variable d&eacute;terminant s'il s'agit du dernier paquet envoy&eacute; au serveur ou pas.
 * @param url url du serveur. 
 * @return vrai si le transfert s'est bien effectu&eacute;, faux sinon.
 */
	public boolean saveDistant(boolean first,boolean last,String url){
		boolean resultat=true;
		String val;
		String msg;
		
		if(last) val="close";
		else val="app";
	
		msg="val="+DataURLAccess.urlEncode(val);
		
		if(m_Num_Rue.length()>0) msg+="&num="+DataURLAccess.urlEncode(m_Num_Rue)+"&vn="+DataURLAccess.urlEncode(v_Num_Rue);
		if(m_Rue.length()>0) msg+="&rue="+DataURLAccess.urlEncode(m_Rue)+"&vr="+DataURLAccess.urlEncode(v_Rue);
		if(m_Ville.length()>0) msg+="&ville="+DataURLAccess.urlEncode(m_Ville)+"&vv="+DataURLAccess.urlEncode(v_Ville);
		if(m_Code_Postal.length()>0) msg+="&code="+DataURLAccess.urlEncode(m_Code_Postal)+"&vc="+DataURLAccess.urlEncode(v_Code_Postal);
		if(m_Telephone.length()>0) msg+="&tel="+DataURLAccess.urlEncode(m_Telephone)+"&vt="+DataURLAccess.urlEncode(v_Telephone);
		if(m_Fax.length()>0) msg+="&fax="+DataURLAccess.urlEncode(m_Fax)+"&vf="+DataURLAccess.urlEncode(v_Fax);
			
		return DataURLAccess.writeData(url,msg);
	}
}
