package SmartAgenda.MyAwt;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;

import Outils.*;
import SmartAgenda.Moteur.*;

/** Classe permettant d'impl&eacute;menter des Buttons avec ActionListener int&eacute;gr&eacute;.
 */
public class MyButton extends Button implements ActionListener{
	private MyFrame frame;
	
	/* gnral : 0 -> 9 */
	public static final int QUIT=0;
	public static final int OK=1;
	public static final int UNDO=2;
	public static final int BACK=3;
	public static final int SAVE=4;
	public static final int INSERT=5;
	public static final int LOAD=6;
	public static final int AFFICHE=7;
	public static final int XML=8;
	
	/* personne : 10 -> 19 */
	public static final int ERASE=10;
	public static final int MODIF=11;
	public static final int NEW=12;
	public static final int ADD=13;
	
	/* postal : 20 -> 29 */
	public static final int NEXT_A=20;
	public static final int PREVIOUS_A=21;
	public static final int SUPP_POSTAL=22;
	public static final int ADD_POSTAL=23;
	public static final int MOD_POSTAL=24;
	
	/* email : 40 -> 49 */
	public static final int SUPP_EMAIL=40;
	public static final int ADD_EMAIL=41;
	
	/* portable : 50 ->59 */
	public static final int SUPP_PORTABLE=50;
	public static final int ADD_PORTABLE=51;
	
	/* calendrier : 60 -> 69 */
	public static final int NEXT_M=60;
	public static final int PREVIOUS_M=61;
	
	private int type;
	
/** Cr&eacute;ation de l'instance.
 * @param s le titre du bouton.
 * @param f la frame poss&eacute;dant le bouton.
 * @param t la valeur num&eacute;rique de l'action li&eacute; au bouton.
 */
	public MyButton(String s, MyFrame f, int t){
		super(s);
		frame=f;
		type=t;
		addActionListener(this);
	}
	
/** Cr&eacute;ation de l'instance.
 * @param f la frame poss&eacute;dant le bouton.
 * @param t la valeur num&eacute;rique de l'action li&eacute; au bouton.
 */
	public MyButton(MyFrame f, int t){
		super();
		frame=f;
		type=t;
		addActionListener(this);
	}
	
	public void actionPerformed (ActionEvent e){
		switch (type){
			case QUIT : frame.quit();break;
			case OK : frame.ok();break;
			case UNDO : frame.undo();break;
			case BACK : frame.back();break;
			case SAVE : frame.save(); break;
			case LOAD : frame.load(); break;
			case MODIF : frame.modif(); break;
			case ERASE : frame.erase(); break;
			case INSERT : frame.insert(); break;
			case NEXT_A : frame.nextAdresse();break;
			case PREVIOUS_A : frame.previousAdresse(); break;
			case AFFICHE : frame.affiche(); break;
			case XML : frame.xml(); break;
			case NEW : frame.nouveau();break;
			case ADD : frame.ajouter();break;
			case SUPP_EMAIL : frame.suppEmail(); break;
			case SUPP_PORTABLE : frame.suppPortable(); break;
			case ADD_EMAIL : frame.addEmail(); break;
			case ADD_PORTABLE : frame.addPortable(); break;
			case SUPP_POSTAL : frame.suppPostal(); break;
			case ADD_POSTAL : frame.addPostal(); break;
			case MOD_POSTAL : frame.modPostal(); break;
			case NEXT_M : frame.nextMonth(); break;
			case PREVIOUS_M : frame.previousMonth(); break;
			default : break;
		}
	}	
}
