package SmartAgenda.Net;

import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;

import Outils.*;

/** Classe permettant l'acc&egrave;s distant au serveur.*/
public class DataURLAccess {

/** Cr&eacute;ation d'une nouvelle instance de la classe.*/
	public DataURLAccess () {}

/**Ecriture de donn&eacute;es dans un fichier sur le serveur.
 * @param url adresse du fichier sur le serveur.
 * @param msg texte &agrave; copier sur le serveur.
 * @return vrai si la copie s'est effectu&eacute;e sans probl&egrave;me, faux sinon.
 */
	public static boolean writeData (String url, String msg){
		try{
			URL u = new URL (url);
			String requete = msg;
			
			try{
				URLConnection uc = u.openConnection();
				uc.setDoOutput(true);
				uc.setDoInput(true);
				uc.setAllowUserInteraction(false);
				DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
				byte byteBuffer [];
			
				dos.writeBytes(requete);
				dos.close();
				
				InputStream dis = uc.getInputStream();
				byteBuffer = new byte[dis.available()];
				dis.read(byteBuffer);
				dis.close();
/* Confirmation de l'enregistrement des donn&eacute;es => Recherche du String "ok" */
				String delim = " \n\r";
				String [] buf;
				String infos = new String(byteBuffer);
System.out.println("Reponse = "+infos);
				StringTokenizer st = new StringTokenizer(infos,delim);
				int limite = st.countTokens();
				buf=new String[limite];
				for(int i=0;i<(limite);i++) {
					buf[i]=st.nextToken();
					if (buf[i].compareToIgnoreCase("OK")==0) return true;
				}
			}
			catch(Exception e){
				System.err.println("writeData : "+e);
				return false;
			}
		}
		catch(MalformedURLException me){
			System.err.println("URL non recevable :"+me.getMessage());
			return false;
		}
		catch (Exception ex){
			System.err.println("URL non recevable :"+ex.getMessage());
			return false;
		}
		return false;
	}

/**Lecture des donn&eacute;es &agrave; partir d'un fichier sur le serveur.
 * @param url adresse du fichier sur le serveur.
 * @return le contenu du fichier lu sur le serveur.
 */
	public static String readData (String url) throws Exception{
		try{
			URL u = new URL (url);
			URLConnection uc = u.openConnection();
			byte byteBuffer [];
			
			uc.setDoOutput(false);
			uc.setDoInput(true);
			uc.setAllowUserInteraction(false);
			try{	
				InputStream dis = uc.getInputStream();
				byteBuffer = new byte[dis.available()];
				dis.read(byteBuffer);
				dis.close();
System.out.println(new String(byteBuffer));
				return (new String(byteBuffer));
			}
			catch(Exception e){
				throw e;
			}
		}
		catch(MalformedURLException me){
			Global.msgErreur("URL non recevable 1:"+me.getMessage(),false);
			throw me;
		}
		catch (IOException ioex){
			Global.msgErreur("URL non recevable 2:"+ioex.getMessage(),false);
			throw ioex;
		}
		catch (Exception ex){
			Global.msgErreur("URL non recevable 3:"+ex.getMessage(),false);
			throw ex;
		}
	}
	
/** Encodage les caract&egrave;res sp&eacute;ciaux.
 * @param la chaine de caract&egrave;res &agrave; encoder.
 * @return la chaine de caract&egrave;res encod&eacute;e.
 */
	public static String urlEncode(String st){

    StringBuffer sb=new StringBuffer();
    String value;
    char c;
    String toEncode ="{}|\\^~[]`;?:@=&%";


    if( st==null ){
      return "";
    }

    for( int i=0; i<st.length(); i++ ){

      c=st.charAt(i);
      if( c==' ' ){
				sb.append('+');
				continue;
      }
      if( Character.isLetterOrDigit(c) ||  toEncode.indexOf(c)==-1 ){
				sb.append(c);
      }
      else {
				sb.append("%"+Integer.toHexString(c));
			}
		}
  	return new String(sb);
	}
	
/** Encodage d'un boolean.
 * @param b le boolean &agrave; encoder.
 * @return la chaine de caract&egrave;res correspondant au boolean encod&eacute;.
 */
	public static String urlEncode(boolean b){
		
		String st=""+b;
    StringBuffer sb=new StringBuffer();
    String value;
    char c;
    String toEncode ="{}|\\^~[]`;?:@=&%";


    if( st==null ){
      return "";
    }

    for( int i=0; i<st.length(); i++ ){

      c=st.charAt(i);
      if( c==' ' ){
				sb.append('+');
				continue;
      }
      if( Character.isLetterOrDigit(c) ||  toEncode.indexOf(c)==-1 ){
				sb.append(c);
      }
      else {
				sb.append("%"+Integer.toHexString(c));
			}
		}
  	return new String(sb);
	}
}
