import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;

public class SaveCal{

  static String[] stringSplit(String st, String sep){

    Vector v=new Vector();
    int n,start=0;
    int sep_start=-1, sep_end=-1;
   
    while( true ){
    	for(int i=0; i<sep.length(); i++) {
			n=st.indexOf(sep.charAt(i),start);
			if( n==-1 ){ continue; }
			if( i==0 ){ sep_start=n; }
			else{ sep_start=min(sep_start,n); }
      }

      if( sep_start>=start ){
			sep_end=sep_start;
			v.addElement(st.substring(start,sep_start));
      }
      else{
			sep_end=start;
			break;
      }
      
      char c;
      sep_end=sep_start;
      while( sep_end<st.length() ){
			c=st.charAt(sep_end);
			if( sep.indexOf(c)==-1) { break; }
			sep_end++;
     	}
      if( sep_end==st.length()) { break;}
      start=sep_end;
    }
    
    v.addElement(st.substring(sep_end));
    String[] r=new String[v.size()];
    v.copyInto(r);
    return r;
  }

  static int max(int n, int m){
    return n<m ? m : n ;
  }
  
  static int min(int n, int m){
    return n>m ? m : n ;
  }


  static Properties decodeArgs(String pa) throws Exception{

    String[] variables=stringSplit(pa,"&");
    Properties Data=new Properties();
    String[] KeyValue;

    for( int i=0; i<variables.length; i++){
      KeyValue=stringSplit(variables[i],"=");
      if( KeyValue.length!=2 ){
			throw new Exception(pa);
      }
      Data.put(KeyValue[0], urlDecode(KeyValue[1]));
    }
    return Data;
  }  
  
static String urlDecode(String st){

    StringBuffer sb=new StringBuffer();
    String value;
    char c;

    for( int i=0; i<st.length(); i++ ){

      if( (c=st.charAt(i))=='%' ){
			value=st.substring(i+1, i+3);
			i=i+2;
			sb.append( (char)Integer.parseInt(value, 16));
      }
      else if(c=='+' ){
			sb.append(' ');
      }
      else{
			sb.append(c);
      }
    }
    return new String(sb);
  }


  static String urlEncode(String st) throws Exception{

    StringBuffer sb=new StringBuffer();
    String value;
    char c;
    String toEncode ="{}|\\^~[]`;?:@=&%";

    if( st==null ){
      throw new NullPointerException();
    }

    for( int i=0; i<st.length(); i++ ){
      c=st.charAt(i);
      if( c==' ' ){
			sb.append('+');
			continue;
      }
      if( Character.isLetterOrDigit(c) ||  toEncode.indexOf(c)==-1 ){
			sb.append(c);
      }
      else {
			sb.append("%"+Integer.toHexString(c));
      }
    }
    return new String(sb);
  }


/* Recuperation du nom du fichier des lecteurs ou des administrateurs,
pour copier les donnees */
/* Appel a la fonction : infosIni, de la classe : SaveUtil*/

	static String nomFichier() {
		String nom="";
		String token="";
		
		token=new String("NETCAL");
		nom = (new String(SaveUtil.infosIni("sagenda",token,"")));
		return nom;	
	}

/* Fonction de transformation du fichier temporaire en agd
et ajout des tags des debut de fichier*/
/* Appel a la fonction : infosIni, de la classe : SaveUtil*/
	static void tmpToAgd (String tmpFic) {

		String repertoire = new String(SaveUtil.infosIni("sagenda","SERVERREP",""));
		FileInputStream tmp;
		FileWriter ficAgd;
		byte [] data;

		//creation et copie dans le fichier agd
		try{
			ficAgd= new FileWriter(repertoire+"/"+tmpFic+".agd",false);
			tmp = new FileInputStream(tmpFic+".tmp");
		 	data = new byte[tmp.available()];
			tmp.read(data);
			tmp.close();
						
			ficAgd.write("<AGENDA>");
			ficAgd.write("\r\n<CAL>");
			ficAgd.write(new String(data));
			ficAgd.close();
			//Suppression du fichier temporaire
			(new File (tmpFic+".tmp")).delete();
		}
		catch(IOException e){
			System.out.println("511 AGD SaveCAL impossible !");
		}
	}

	public static void main(String[] args) throws Exception{ 
		// On rcupre les speudo var. d'env. qui sont Content-length, 
		// Query String et Request Method
		String method=System.getProperty("REQUEST_METHOD");
		String data;

			if( method.equals("GET") ){
				// les donnes sont passes dans Query_String
				data=System.getProperty("QUERY_STRING");
				System.out.println("514 Methode GET non implementee.");
			}
			else{	
				//Mthode POST
				// on rcupre la taille des donnes et on lit sur l'entre standard du programme 
				int n=Integer.parseInt(System.getProperty("CONTENT_LENGTH"));
				byte buf[]= new byte[n];
				System.in.read(buf);
				// on transforme en chaine de caractre 
				data=new String(buf);
			}

			Properties p = decodeArgs(data);
System.out.println(data);
			String contexte = p.getProperty("val","");
			String dd = p.getProperty("dd","");
			String df = p.getProperty("df","");
			String hd = p.getProperty("hd","");
			String hf = p.getProperty("hf","");
			String objet = p.getProperty("objet","");
			String desc = p.getProperty("desc","");
			String id = p.getProperty("id","");
			String url = p.getProperty("url","");
			String first = p.getProperty("first","");
	
			int nb=0;
			boolean append = false;
			boolean close = false;
			boolean personne = false;
		   FileWriter ficTempo;
		   
		   //Fichier ou l'on va copier les donnees
		   String fnom = new String(nomFichier());
			//Maintenant on peut ecrire
		   if (fnom.compareTo("")!=0) {
				//Fichier en append ou en creation
				if (contexte.compareToIgnoreCase("new")==0) {
					append = false;
					close = false;
				}
				if (contexte.compareToIgnoreCase("only")==0)	{
					close=true;
					append = false;
				}
				if (contexte.compareToIgnoreCase("app")==0) {
					append=true;
					close=false;
				}
				if (contexte.compareToIgnoreCase("close")==0) {
					append=true;
					close=true;
				}
				//Fichier temporaire pour copier les donnees
		   	try{
					ficTempo = new FileWriter(fnom+".tmp",append);			
					//Donnees a copier

					if (dd.length()>0) {
						ficTempo.write("\r\n<PH>");
						ficTempo.write("<DD>"+dd);
						if (df.length()>0) ficTempo.write("<DF>"+df);
						if (hd.length()>0) ficTempo.write("<HD>"+hd);
						if (hf.length()>0) ficTempo.write("<HF>"+hf);
					}
					if (objet.length()>0)
						ficTempo.write("<OBJET>"+objet);
					if (desc.length()>0)
						ficTempo.write("<DESC>"+desc);
					if (id.length()>0) {
						if (first.length()>0) {
							personne = (Boolean.valueOf(first)).booleanValue();
							if(personne) ficTempo.write("<PERSONNE>");
						}
						ficTempo.write("<ID>"+id);
					}
					if (url.length()>0) {
						ficTempo.write("<URL>"+url);
					}
					ficTempo.close();
					//Transformation du fichier tmp en agd, toutes les donnees sont reues.
					if (close) {
						//Copie du fichier temporaire en agd dans le bon repertoire
						//et suppression du fichier temporaire.
						tmpToAgd(fnom);
					}	
					System.out.println("200 OK");
				}
				catch(IOException e){ System.out.println("510 Creation NETCAL impossible !");}
			}
			else 	System.out.println("512 NomFichier NETCAL inexistant !");
}

}

