import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.*;
import java.awt.*;

public class SaveUtil{

  static String[] stringSplit(String st, String sep){

    Vector v=new Vector();
    int n,start=0;
    int sep_start=-1, sep_end=-1;
   
    while( true ){
    	for(int i=0; i<sep.length(); i++) {
			n=st.indexOf(sep.charAt(i),start);
			if( n==-1 ){ continue; }
			if( i==0 ){ sep_start=n; }
			else{ sep_start=min(sep_start,n); }
      }

      if( sep_start>=start ){
			sep_end=sep_start;
			v.addElement(st.substring(start,sep_start));
      }
      else{
			sep_end=start;
			break;
      }
      
      char c;
      sep_end=sep_start;
      while( sep_end<st.length() ){
			c=st.charAt(sep_end);
			if( sep.indexOf(c)==-1) { break; }
			sep_end++;
     	}
      if( sep_end==st.length()) { break;}
      start=sep_end;
    }
    
    v.addElement(st.substring(sep_end));
    String[] r=new String[v.size()];
    v.copyInto(r);
    return r;
  }

  static int max(int n, int m){
    return n<m ? m : n ;
  }
  
  static int min(int n, int m){
    return n>m ? m : n ;
  }


  static Properties decodeArgs(String pa) throws Exception{

    String[] variables=stringSplit(pa,"&");
    Properties Data=new Properties();
    String[] KeyValue;

    for( int i=0; i<variables.length; i++){
      KeyValue=stringSplit(variables[i],"=");
      if( KeyValue.length!=2 ){
			throw new Exception(pa);
      }
      Data.put(KeyValue[0], urlDecode(KeyValue[1]));
    }
    return Data;
  }  
  
static String urlDecode(String st){

    StringBuffer sb=new StringBuffer();
    String value;
    char c;

    for( int i=0; i<st.length(); i++ ){

      if( (c=st.charAt(i))=='%' ){
			value=st.substring(i+1, i+3);
			i=i+2;
			sb.append( (char)Integer.parseInt(value, 16));
      }
      else if(c=='+' ){
			sb.append(' ');
      }
      else{
			sb.append(c);
      }
    }
    return new String(sb);
  }


  static String urlEncode(String st) throws Exception{

    StringBuffer sb=new StringBuffer();
    String value;
    char c;
    String toEncode ="{}|\\^~[]`;?:@=&%";

    if( st==null ){
      throw new NullPointerException();
    }

    for( int i=0; i<st.length(); i++ ){
      c=st.charAt(i);
      if( c==' ' ){
			sb.append('+');
			continue;
      }
      if( Character.isLetterOrDigit(c) ||  toEncode.indexOf(c)==-1 ){
			sb.append(c);
      }
      else {
			sb.append("%"+Integer.toHexString(c));
      }
    }
    return new String(sb);
  }


/* Recherche d'informations dans un fichier selon un mot cle,
un repertoire et le nom du fichier ==> Adapter au fichiers INI uniquement*/
	public static String infosIni (String ficIni, String tag, String rep){
		String token=""; //ce que l'on recupere
		String repSrc= new String (rep);
		String tmpRep;
		String nomFicIni= new String(ficIni);
		String nomTag = new String("["+tag+"]");
		String encours="";
		FileInputStream fic;

		try{
			if (repSrc.length()>0) tmpRep = new String(rep+"/"+nomFicIni+".ini");
			else tmpRep = new String(nomFicIni+".ini");

			fic = new FileInputStream (tmpRep);
			byte[] buffer = new byte[fic.available()];
			fic.read(buffer);
			String buf=new String(buffer);
			String delim = new String("\r\n");
			StringTokenizer st=new StringTokenizer(buf,delim);
			int limite= st.countTokens();

			for(int i=0;i<limite-1;i++) {
				encours = st.nextToken();
				if (encours.compareToIgnoreCase(nomTag)==0){
					token = st.nextToken();
					fic.close();
					return token;
				}
			}
		return "";
		}
		catch(IOException e){
			System.out.println("512 Informations introuvables dans fichier INI");
			return "";
		}		
	}

/* Recuperation du nom du fichier des lecteurs ou des administrateurs,
pour copier les donnees */
	static String nomFichier(boolean lecteur) {
		String nom="";
		String token="";
		boolean typeUtil=lecteur;
		
		if (typeUtil) token=new String("NETLEC");
		else token=new String("NETADM");

		nom = (new String(infosIni("sagenda",token,"")));
		return nom;	
	}

/* Fonction de transformation du fichier temporaire en agd
et remise en forme du fichier agd (suppression des retours a
la ligne superflus et genants)*/
	static void tmpToAgd (String tmpFic,boolean lecteur) {

		String repertoire = new String(infosIni("sagenda","SERVERREP",""));
		FileInputStream tmp;
		FileWriter ficAgd;
		byte [] data;
		boolean adresse=false;
		boolean autre=false;

		//creation et copie dans le fichier agd
		try{
			ficAgd= new FileWriter(repertoire+"/"+tmpFic+".agd",false);
			tmp = new FileInputStream(tmpFic+".tmp");
		 	data = new byte[tmp.available()];
			tmp.read(data);
			tmp.close();
			String delim="\r\n";
						
			ficAgd.write("<AGENDA>");
			if(lecteur)ficAgd.write("\r\n<LEC>");
			else ficAgd.write("\r\n<ADMIN>");
			
			StringTokenizer st=new StringTokenizer(new String(data),delim);
			int limite=st.countTokens();
			String[] buf= new String[limite];

			for(int i=0;i<limite;i++) buf[i]=st.nextToken();
			for(int i=0;i<limite;i++){
				if(buf[i].substring(0,6).compareToIgnoreCase("<UTIL>")==0){
					ficAgd.write("\r\n"+buf[i]);
					adresse=false;
					autre=false;
				}
				else if(buf[i].substring(0,8).compareToIgnoreCase("<POSTAL>")==0){
					if(!adresse){
						autre=false;
						adresse=true;
						ficAgd.write("<ADRESSE>");
					}
					ficAgd.write(buf[i]);
				}
				else if(buf[i].substring(0,6).compareToIgnoreCase("<EMAIL")==0){
					if(!adresse){
						autre=false;
						adresse=true;
						ficAgd.write("<ADRESSE>");
					}
					if(!autre){
						autre=true;
						ficAgd.write("<AUTRE>");
					}
					ficAgd.write(buf[i]);
				}
				else if(buf[i].substring(0,9).compareToIgnoreCase("<PORTABLE")==0){
					if(!adresse){
						autre=false;
						adresse=true;
						ficAgd.write("<ADRESSE>");
					}
					if(!autre){
						autre=true;
						ficAgd.write("<AUTRE>");
					}
					ficAgd.write(buf[i]);
				}
			}			
			ficAgd.close();
			//Suppression du fichier temporaire
			(new File (tmpFic+".tmp")).delete();
			
		}
		catch(IOException e){
			System.out.println("511 AGD SaveUTIL impossible !");
		}
	}

	public static void main(String[] args) throws Exception{ 
		// On rcupre les speudo var. d'env. qui sont Content-length, 
		// Query String et Request Method
		String method=System.getProperty("REQUEST_METHOD");
		String data;
		String typeUtil;
		boolean lecteur = false;

		//Determine le type d'utilisateur
		if (args.length>0) {
			typeUtil = args[0];

			if (typeUtil.compareToIgnoreCase("LEC")==0) lecteur=true;
			else lecteur = false;

			if( method.equals("GET") ){
				// les donnes sont passes dans Query_String
				data=System.getProperty("QUERY_STRING");
				System.out.println("514 Methode GET non implementee.");
			}
			else{	
				//Mthode POST
				// on rcupre la taille des donnes et on lit sur l'entre standard du programme 
				int n=Integer.parseInt(System.getProperty("CONTENT_LENGTH"));
				byte buf[]= new byte[n];
				System.in.read(buf);
				// on transforme en chaine de caractre 
				data=new String(buf);
			}

			Properties p = decodeArgs(data);
System.out.println(data);
			String contexte = p.getProperty("val","");
			String id = p.getProperty("id","");
			String nom = p.getProperty("nom","");
			String prenom = p.getProperty("prenom","");
			String login = p.getProperty("login","");
			String email = p.getProperty("email","");
			String ve = p.getProperty("ve","");
			String portable = p.getProperty("portable","");
			String vp = p.getProperty("vp","");
			String num = p.getProperty("num","");
			String vn = p.getProperty("vn","");
			String rue = p.getProperty("rue","");
			String vr = p.getProperty("vr","");
			String ville = p.getProperty("ville","");
			String vv = p.getProperty("vv","");
			String code = p.getProperty("code","");
			String vc = p.getProperty("vc","");
			String tel = p.getProperty("tel","");
			String vt = p.getProperty("vt","");
			String fax = p.getProperty("fax","");
			String vf = p.getProperty("vf","");
			
			boolean append = false;
			boolean close = false;
			boolean postal = false;
		   FileWriter ficTempo;
		   
		   //Fichier ou l'on va copier les donnees
		   String fnom = new String(nomFichier(lecteur));
			//Maintenant on peut ecrire
		   if (fnom.compareTo("")!=0) {
				//Fichier en append ou en creation
				if (contexte.compareToIgnoreCase("new")==0) {
					append = false;
					close = false;
				}
				if (contexte.compareToIgnoreCase("only")==0)	{
					close=true;
					append = false;
				}
				if (contexte.compareToIgnoreCase("app")==0) {
					append=true;
					close=false;
				}
				if (contexte.compareToIgnoreCase("close")==0) {
					append=true;
					close=true;
				}
				//Fichier temporaire pour copier les donnees
		   	try{
					ficTempo = new FileWriter(fnom+".tmp",append);			
					//Donnees a copier

					if (id.length()>0) {
						ficTempo.write("\r\n<UTIL>");
						ficTempo.write("<ID>"+id);
						if (nom.length()>0) ficTempo.write("<NOM>"+nom);
						if (prenom.length()>0) ficTempo.write("<PRENOM>"+prenom);
						if (login.length()>0) ficTempo.write("<LOGIN>"+login);
					}
					if (num.length()>0) {
						if(!postal){
							postal=true;
							ficTempo.write("\r\n<POSTAL>");
						}
						if (vn.length()>0) ficTempo.write("<NUM VIEW="+vn+">"+num);
						else ficTempo.write("<NUM VIEW=false>"+num);
					}
					if (rue.length()>0) {
						if(!postal){
							postal=true;
							ficTempo.write("\r\n<POSTAL>");
						}
						if (vr.length()>0) ficTempo.write("<RUE VIEW="+vr+">"+rue);
						else ficTempo.write("<RUE VIEW=false>"+rue);
					}
					if (ville.length()>0) {
						if(!postal){
							postal=true;
							ficTempo.write("\r\n<POSTAL>");
						}
						if (vv.length()>0) ficTempo.write("<VILLE VIEW="+vv+">"+ville);
						else ficTempo.write("<VILLE VIEW=false>"+ville);
					}
					if (code.length()>0) {
						if(!postal){
							postal=true;
							ficTempo.write("\r\n<POSTAL>");
						}
						if (vc.length()>0) ficTempo.write("<CODE VIEW="+vc+">"+code);
						else ficTempo.write("<CODE VIEW=false>"+code);
					}
					if (tel.length()>0) {
						if(!postal){
							postal=true;
							ficTempo.write("\r\n<POSTAL>");
						}
						if (vt.length()>0) ficTempo.write("<TEL VIEW="+vt+">"+tel);
						else ficTempo.write("<TEL VIEW=false>"+tel);
					}
					if (fax.length()>0) {
						if(!postal){
							postal=true;
							ficTempo.write("\r\n<POSTAL>");
						}
						if (vf.length()>0) ficTempo.write("<FAX VIEW="+vf+">"+fax);
						else ficTempo.write("<FAX VIEW=false>"+fax);
					}
					if (email.length()>0) {
						if (ve.length()>0)	ficTempo.write("\r\n<EMAIL VIEW="+ve+">"+email);
						else ficTempo.write("\r\n<EMAIL VIEW=false>"+email);
					}
					if (portable.length()>0) {
						if (vp.length()>0) ficTempo.write("\r\n<PORTABLE VIEW="+vp+">"+portable);
						else ficTempo.write("\r\n<PORTABLE VIEW=false>"+portable);
					}
					ficTempo.close();
					//Transformation du fichier tmp en agd, toutes les donnees sont reues.
					if (close) {
						//Copie du fichier temporaire en agd dans le bon repertoire
						//et suppression du fichier temporaire.
						tmpToAgd(fnom,lecteur);
					}	
					System.out.println("200 OK");
				}
				catch(IOException e){ System.out.println("510 Creation NETUTIL impossible !");}
			}
			else 	System.out.println("512 NomFichier NETUTIL inexistant !");
		}
		else System.out.println("513 Bad CGI NETUTIL !");
}

}

